
// SampleChart.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "SampleChart.h"
#include "SampleChartDlg.h"
#include <afxmt.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CSampleChartApp

BEGIN_MESSAGE_MAP(CSampleChartApp, CWinApp)
	ON_COMMAND(ID_HELP, &CWinApp::OnHelp)
END_MESSAGE_MAP()

class Test_DuplicatePlotData1D :
	public std::binary_function<Array1D_Double, Array1D_Double, bool>
{
public:
	bool operator()(const Array1D_Double& info1, const Array1D_Double &info2) const;
};
bool Test_DuplicatePlotData1D::operator()(const Array1D_Double& info1, const Array1D_Double &info2) const
{
	if (info1.size() != info2.size())
		return false;

	for (size_t i = 0; i < info1.size(); ++i)
	{
		if (info1[i] != info2[i])
			return false;
	}

	return true;
}

class Test_DuplicatePlotData2D :
	public std::binary_function<Array2D_Double, Array2D_Double, bool>
{
public:
	bool operator()(const Array2D_Double& info1, const Array2D_Double &info2) const;
};
bool Test_DuplicatePlotData2D::operator()(const Array2D_Double& info1, const Array2D_Double &info2) const
{
	if (info1.rows() != info2.rows() || info1.cols() != info2.cols())
		return false;

	for (size_t i = 0; i < info1.rows(); ++i)
	{
		for (size_t j = 0; j < info1.cols(); ++j)
		{
			if (info1[i][j] != info2[i][j])
				return false;
		}
	}

	return true;
}

class Test_DuplicatePlotData :
	public std::binary_function<double, double, bool>
{
public:
	bool operator()(const double& info1, const double &info2) const;
};
bool Test_DuplicatePlotData::operator()(const double& info1, const double &info2) const
{
	if (info1 != info2)
		return false;

	return true;
}



CStLineProperty::CStLineProperty()
{
	m_nXY1LineColor = -1;
	m_nXY1LineStyle = -1;
	m_nXY1LineWidth = -1;
	m_nXY1PointStyle = -1;
	m_nXY1PointColor = -1;
	m_nXY1PointSize = -1;

	m_nXY2LineColor = -1;
	m_nXY2LineStyle = -1;
	m_nXY2LineWidth = -1;
	m_nXY2PointStyle = -1;
	m_nXY2PointColor = -1;
	m_nXY2PointSize = -1;

}

CStLineProperty::CStLineProperty(const CStLineProperty& source)
{
	m_nXY1LineColor = source.m_nXY1LineColor;
	m_nXY1LineStyle = source.m_nXY1LineStyle;
	m_nXY1LineWidth = source.m_nXY1LineWidth;
	m_nXY1PointStyle = source.m_nXY1PointStyle;
	m_nXY1PointColor = source.m_nXY1PointColor;
	m_nXY1PointSize = source.m_nXY1PointSize;

	m_nXY2LineColor = source.m_nXY2LineColor;
	m_nXY2LineStyle = source.m_nXY2LineStyle;
	m_nXY2LineWidth = source.m_nXY2LineWidth;
	m_nXY2PointStyle = source.m_nXY2PointStyle;
	m_nXY2PointColor = source.m_nXY2PointColor;
	m_nXY2PointSize = source.m_nXY2PointSize;
}

CStLineProperty& CStLineProperty::operator = (const CStLineProperty& source)
{
	if (this == &source)
		return *this;

	m_nXY1LineColor = source.m_nXY1LineColor;
	m_nXY1LineStyle = source.m_nXY1LineStyle;
	m_nXY1LineWidth = source.m_nXY1LineWidth;
	m_nXY1PointStyle = source.m_nXY1PointStyle;
	m_nXY1PointColor = source.m_nXY1PointColor;
	m_nXY1PointSize = source.m_nXY1PointSize;

	m_nXY2LineColor = source.m_nXY2LineColor;
	m_nXY2LineStyle = source.m_nXY2LineStyle;
	m_nXY2LineWidth = source.m_nXY2LineWidth;
	m_nXY2PointStyle = source.m_nXY2PointStyle;
	m_nXY2PointColor = source.m_nXY2PointColor;
	m_nXY2PointSize = source.m_nXY2PointSize;

	return *this;
}

bool CStLineProperty::operator == (const CStLineProperty& source1) const
{
	if (source1.m_nXY1LineColor == m_nXY1LineColor &&
		source1.m_nXY1LineStyle == m_nXY1LineStyle &&
		source1.m_nXY1LineWidth == m_nXY1LineWidth &&
		source1.m_nXY1PointStyle == m_nXY1PointStyle &&
		source1.m_nXY1PointColor == m_nXY1PointColor &&
		source1.m_nXY1PointSize == m_nXY1PointSize &&
		source1.m_nXY2LineColor == m_nXY2LineColor &&
		source1.m_nXY2LineStyle == m_nXY2LineStyle &&
		source1.m_nXY2LineWidth == m_nXY2LineWidth &&
		source1.m_nXY2PointStyle == m_nXY2PointStyle &&
		source1.m_nXY2PointColor == m_nXY2PointColor &&
		source1.m_nXY2PointSize == m_nXY2PointSize)
		return true;

	return false;
}

CStLineProperty::~CStLineProperty()
{

}

CStGIS_AnalyzerData::CStGIS_AnalyzerData()
{
	m_nSizeInPercentage = 0;
	m_nXCoord = 0;
	m_nYCoord = 0;
	m_nWidth = 0;
	m_nHeight = 0;
	m_nTextCount = 0;
	m_nGraphcount = 0;
	enable_close_ = 1;
}
CStGIS_AnalyzerData::~CStGIS_AnalyzerData()
{
	//TRACE("\nDestroying CStGIS_AnalyzerData Packet\n");
}

///////////////////////////////////////////////////////////////////////////////////////////////////////
//

CStGIS_AnalyzerData::CStGIS_AnalyzerData(const CStGIS_AnalyzerData& source)
{
	m_strTestName = source.m_strTestName;
	m_strTesterID = source.m_strTesterID;
	m_strCommandName = source.m_strCommandName;
	m_nSizeInPercentage = source.m_nSizeInPercentage;
	m_nXCoord = source.m_nXCoord;
	m_nYCoord = source.m_nYCoord;
	m_nWidth = source.m_nWidth;
	m_nHeight = source.m_nHeight;
	m_nTextCount = source.m_nTextCount;
	m_nGraphcount = source.m_nGraphcount;
	enable_close_ = source.enable_close_;
}

///////////////////////////////////////////////////////////////////////////////////////////
//

CStGIS_AnalyzerData& CStGIS_AnalyzerData::operator = (const CStGIS_AnalyzerData& source)
{
	if (this == &source)
		return *this;

	m_strTestName = source.m_strTestName;
	m_strTesterID = source.m_strTesterID;
	m_strCommandName = source.m_strCommandName;
	m_nSizeInPercentage = source.m_nSizeInPercentage;
	m_nXCoord = source.m_nXCoord;
	m_nYCoord = source.m_nYCoord;
	m_nWidth = source.m_nWidth;
	m_nHeight = source.m_nHeight;
	m_nTextCount = source.m_nTextCount;
	m_nGraphcount = source.m_nGraphcount;
	enable_close_ = source.enable_close_;

	return *this;
}


/////////////////////////////////////////////////////////////////////////////////////
//

CStGIS_GraphData::CStGIS_GraphData()
{
	m_nLineColor = 0;  // default is RED
	m_nLine2Color = 1;  // default is GREEN

	m_nXYColor = 0;
	m_nXY2Color = 1;
}
CStGIS_GraphData::~CStGIS_GraphData()
{
	//TRACE("\nDestroying CStGIS_GraphData Packet\n");
}

/////////////////////////////////////////////////////////////////////////////////////
//

CStGIS_GraphData::CStGIS_GraphData(const CStGIS_GraphData& source)
{
	m_strTestName = source.m_strTestName;
	m_strTesterID = source.m_strTesterID;
	m_strCommandName = source.m_strCommandName;

	m_nSequenceID = source.m_nSequenceID;
	m_nGraphDataType = source.m_nGraphDataType;
	m_dXSingleXValue = source.m_dXSingleXValue;
	m_dXSingleXY1Value = source.m_dXSingleXY1Value;
	m_dXSingleXY2Value = source.m_dXSingleXY2Value;
	m_nDataUpdateMode = source.m_nDataUpdateMode;
	m_nLineColor = source.m_nLineColor;
	m_nLine2Color = source.m_nLine2Color;
	m_nXYColor = source.m_nXYColor;
	m_nXY2Color = source.m_nXY2Color;

	m_stObjProp.m_bAutoScale = source.m_stObjProp.m_bAutoScale;
	m_stObjProp.m_bXScale = source.m_stObjProp.m_bXScale;
	m_stObjProp.m_bY1Scale = source.m_stObjProp.m_bY1Scale;
	m_stObjProp.m_bY2Scale = source.m_stObjProp.m_bY2Scale;

	m_stObjProp.m_dXAxisMax = source.m_stObjProp.m_dXAxisMax;
	m_stObjProp.m_dXAxisMin = source.m_stObjProp.m_dXAxisMin;

	m_stObjProp.m_dY1AxisMin = source.m_stObjProp.m_dY1AxisMin;
	m_stObjProp.m_dY1AxisMax = source.m_stObjProp.m_dY1AxisMax;

	m_stObjProp.m_dY2AxisMin = source.m_stObjProp.m_dY2AxisMin;
	m_stObjProp.m_dY2AxisMax = source.m_stObjProp.m_dY2AxisMax;

	m_stObjProp.m_strXAxisName = source.m_stObjProp.m_strXAxisName;
	m_stObjProp.m_strY1AxisName = source.m_stObjProp.m_strY1AxisName;
	m_stObjProp.m_strComment1 = source.m_stObjProp.m_strComment1;
	m_stObjProp.m_strY2AxisName = source.m_stObjProp.m_strY2AxisName;
	m_stObjProp.m_strGraphName = source.m_stObjProp.m_strGraphName;
	m_stObjProp.m_iUpdateMode = source.m_stObjProp.m_iUpdateMode;

	m_stObjLine.m_nXY1LineColor = source.m_stObjLine.m_nXY1LineColor;
	m_stObjLine.m_nXY1LineStyle = source.m_stObjLine.m_nXY1LineStyle;
	m_stObjLine.m_nXY1LineWidth = source.m_stObjLine.m_nXY1LineWidth;
	m_stObjLine.m_nXY1PointColor = source.m_stObjLine.m_nXY1PointColor;
	m_stObjLine.m_nXY1PointSize = source.m_stObjLine.m_nXY1PointSize;
	m_stObjLine.m_nXY1PointStyle = source.m_stObjLine.m_nXY1PointStyle;
	m_stObjLine.m_nXY2LineColor = source.m_stObjLine.m_nXY2LineColor;
	m_stObjLine.m_nXY2LineStyle = source.m_stObjLine.m_nXY2LineStyle;
	m_stObjLine.m_nXY2LineWidth = source.m_stObjLine.m_nXY2LineWidth;
	m_stObjLine.m_nXY2PointColor = source.m_stObjLine.m_nXY2PointColor;
	m_stObjLine.m_nXY2PointSize = source.m_stObjLine.m_nXY2PointSize;
	m_stObjLine.m_nXY2PointStyle = source.m_stObjLine.m_nXY2PointStyle;

	m_vec_XAxisValues = source.m_vec_XAxisValues;
	m_vec_Y1AxisValues = source.m_vec_Y1AxisValues;
	m_vec_Y2AxisValues = source.m_vec_Y2AxisValues;

	m_vec_2DY1AxisValues = source.m_vec_2DY1AxisValues;
	m_vec_2DY2AxisValues = source.m_vec_2DY2AxisValues;

}

/////////////////////////////////////////////////////////////////////////////////////
//

CStGIS_GraphData& CStGIS_GraphData::operator = (const CStGIS_GraphData& source)
{
	if (this == &source)
		return *this;

	m_strTestName = source.m_strTestName;
	m_strTesterID = source.m_strTesterID;
	m_strCommandName = source.m_strCommandName;

	m_nSequenceID = source.m_nSequenceID;
	m_nGraphDataType = source.m_nGraphDataType;
	m_dXSingleXValue = source.m_dXSingleXValue;
	m_dXSingleXY1Value = source.m_dXSingleXY1Value;
	m_dXSingleXY2Value = source.m_dXSingleXY2Value;
	m_nDataUpdateMode = source.m_nDataUpdateMode;
	m_nLineColor = source.m_nLineColor;
	m_nLine2Color = source.m_nLine2Color;
	m_nXYColor = source.m_nXYColor;
	m_nXY2Color = source.m_nXY2Color;

	m_stObjProp.m_bAutoScale = source.m_stObjProp.m_bAutoScale;
	m_stObjProp.m_bXScale = source.m_stObjProp.m_bXScale;
	m_stObjProp.m_bY1Scale = source.m_stObjProp.m_bY1Scale;
	m_stObjProp.m_bY2Scale = source.m_stObjProp.m_bY2Scale;
	m_stObjProp.m_dXAxisMax = source.m_stObjProp.m_dXAxisMax;
	m_stObjProp.m_dXAxisMin = source.m_stObjProp.m_dXAxisMin;

	m_stObjProp.m_dY1AxisMin = source.m_stObjProp.m_dY1AxisMin;
	m_stObjProp.m_dY1AxisMax = source.m_stObjProp.m_dY1AxisMax;

	m_stObjProp.m_dY2AxisMin = source.m_stObjProp.m_dY2AxisMin;
	m_stObjProp.m_dY2AxisMax = source.m_stObjProp.m_dY2AxisMax;

	m_stObjProp.m_strXAxisName = source.m_stObjProp.m_strXAxisName;
	m_stObjProp.m_strY1AxisName = source.m_stObjProp.m_strY1AxisName;
	m_stObjProp.m_strComment1 = source.m_stObjProp.m_strComment1;
	m_stObjProp.m_strY2AxisName = source.m_stObjProp.m_strY2AxisName;
	m_stObjProp.m_strGraphName = source.m_stObjProp.m_strGraphName;
	m_stObjProp.m_iUpdateMode = source.m_stObjProp.m_iUpdateMode;

	m_stObjLine.m_nXY1LineColor = source.m_stObjLine.m_nXY1LineColor;
	m_stObjLine.m_nXY1LineStyle = source.m_stObjLine.m_nXY1LineStyle;
	m_stObjLine.m_nXY1LineWidth = source.m_stObjLine.m_nXY1LineWidth;
	m_stObjLine.m_nXY1PointColor = source.m_stObjLine.m_nXY1PointColor;
	m_stObjLine.m_nXY1PointSize = source.m_stObjLine.m_nXY1PointSize;
	m_stObjLine.m_nXY1PointStyle = source.m_stObjLine.m_nXY1PointStyle;
	m_stObjLine.m_nXY2LineColor = source.m_stObjLine.m_nXY2LineColor;
	m_stObjLine.m_nXY2LineStyle = source.m_stObjLine.m_nXY2LineStyle;
	m_stObjLine.m_nXY2LineWidth = source.m_stObjLine.m_nXY2LineWidth;
	m_stObjLine.m_nXY2PointColor = source.m_stObjLine.m_nXY2PointColor;
	m_stObjLine.m_nXY2PointSize = source.m_stObjLine.m_nXY2PointSize;
	m_stObjLine.m_nXY2PointStyle = source.m_stObjLine.m_nXY2PointStyle;

	m_vec_XAxisValues = source.m_vec_XAxisValues;
	m_vec_Y1AxisValues = source.m_vec_Y1AxisValues;
	m_vec_Y2AxisValues = source.m_vec_Y2AxisValues;

	m_vec_2DY1AxisValues = source.m_vec_2DY1AxisValues;
	m_vec_2DY2AxisValues = source.m_vec_2DY2AxisValues;



	return *this;
}


CStGIS_TextData::CStGIS_TextData()
{
}

CStGIS_TextData::~CStGIS_TextData()
{
	//TRACE("\nDestroying CStGIS_TextData Packet\n");
}

/////////////////////////////////////////////////////////////////////////////////////
//

CStGIS_TextData::CStGIS_TextData(const CStGIS_TextData& source)
{
	m_strTestName = source.m_strTestName;
	m_strTesterID = source.m_strTesterID;
	m_strCommandName = source.m_strCommandName;

	m_nSequenceID = source.m_nSequenceID;
	m_nUpdateMode = source.m_nUpdateMode;
	m_nTextDataType = source.m_nTextDataType;

	m_dSingleValues = source.m_dSingleValues;
	m_nSingleValues = source.m_nSingleValues;

	m_vec_paramname = source.m_vec_paramname;
	m_vec_2DValues = source.m_vec_2DValues;


}

/////////////////////////////////////////////////////////////////////////////////////
//

CStGIS_TextData& CStGIS_TextData::operator = (const CStGIS_TextData& source)
{
	if (this == &source)
		return *this;

	m_strTestName = source.m_strTestName;
	m_strTesterID = source.m_strTesterID;
	m_strCommandName = source.m_strCommandName;

	m_nSequenceID = source.m_nSequenceID;
	m_nUpdateMode = source.m_nUpdateMode;
	m_nTextDataType = source.m_nTextDataType;

	m_dSingleValues = source.m_dSingleValues;
	m_nSingleValues = source.m_nSingleValues;

	m_vec_paramname = source.m_vec_paramname;
	m_vec_2DValues = source.m_vec_2DValues;

	return *this;
}

bool CPlot_Data::operator==(const CPlot_Data& source1) const
{
	if (source1.deq_d1XAxisVal.size() != deq_d1XAxisVal.size())
		return false;

	bool flag = std::equal(source1.deq_d1XAxisVal.begin(), source1.deq_d1XAxisVal.end(), deq_d1XAxisVal.begin(), Test_DuplicatePlotData1D());

	if (!flag)
		return false;

	/////////////////

	if (source1.deq_d1Y2AxisVal.size() != deq_d1Y2AxisVal.size())
		return false;

	flag = std::equal(source1.deq_d1Y2AxisVal.begin(), source1.deq_d1Y2AxisVal.end(), deq_d1Y2AxisVal.begin(), Test_DuplicatePlotData1D());

	if (!flag)
		return false;

	///////////////////

	if (source1.deq_d1YAxisVal.size() != deq_d1YAxisVal.size())
		return false;

	flag = std::equal(source1.deq_d1YAxisVal.begin(), source1.deq_d1YAxisVal.end(), deq_d1YAxisVal.begin(), Test_DuplicatePlotData1D());

	if (!flag)
		return false;

	//////////////////////////////////////////////////////////

	if (source1.deq_d2XAxisVal.size() != deq_d2XAxisVal.size())
		return false;

	flag = std::equal(source1.deq_d2XAxisVal.begin(), source1.deq_d2XAxisVal.end(), deq_d2XAxisVal.begin(), Test_DuplicatePlotData2D());

	if (!flag)
		return false;

	//////////////////

	if (source1.deq_d2Y2AxisVal.size() != deq_d2Y2AxisVal.size())
		return false;

	flag = std::equal(source1.deq_d2Y2AxisVal.begin(), source1.deq_d2Y2AxisVal.end(), deq_d2Y2AxisVal.begin(), Test_DuplicatePlotData2D());

	if (!flag)
		return false;

	///////////////////

	if (source1.deq_d2YAxisVal.size() != deq_d2YAxisVal.size())
		return false;

	flag = std::equal(source1.deq_d2YAxisVal.begin(), source1.deq_d2YAxisVal.end(), deq_d2YAxisVal.begin(), Test_DuplicatePlotData2D());

	if (!flag)
		return false;

	////////////////////////////////////////////////////////

	if (source1.deq_dXAxisVal.size() != deq_dXAxisVal.size())
		return false;

	flag = std::equal(source1.deq_dXAxisVal.begin(), source1.deq_dXAxisVal.end(), deq_dXAxisVal.begin(), Test_DuplicatePlotData());

	if (!flag)
		return false;

	/////////////////

	if (source1.deq_dY2AxisVal.size() != deq_dY2AxisVal.size())
		return false;

	flag = std::equal(source1.deq_dY2AxisVal.begin(), source1.deq_dY2AxisVal.end(), deq_dY2AxisVal.begin(), Test_DuplicatePlotData());

	if (!flag)
		return false;

	////////////////

	if (source1.deq_dYAxisVal.size() != deq_dYAxisVal.size())
		return false;

	flag = std::equal(source1.deq_dYAxisVal.begin(), source1.deq_dYAxisVal.end(), deq_dYAxisVal.begin(), Test_DuplicatePlotData());

	if (!flag)
		return false;

	///////////////////////////////////////////////////////

	if (source1.plot_line_id_ != plot_line_id_)
		return false;

	if (source1.line_prop == line_prop)
		return true;

	return false;

}



// CSampleChartApp construction

CSampleChartApp::CSampleChartApp()
{
	// support Restart Manager
	m_dwRestartManagerSupportFlags = AFX_RESTART_MANAGER_SUPPORT_RESTART;

	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}


// The one and only CSampleChartApp object

CSampleChartApp theApp;


// CSampleChartApp initialization

BOOL CSampleChartApp::InitInstance()
{
	// InitCommonControlsEx() is required on Windows XP if an application
	// manifest specifies use of ComCtl32.dll version 6 or later to enable
	// visual styles.  Otherwise, any window creation will fail.
	INITCOMMONCONTROLSEX InitCtrls;
	InitCtrls.dwSize = sizeof(InitCtrls);
	// Set this to include all the common control classes you want to use
	// in your application.
	InitCtrls.dwICC = ICC_WIN95_CLASSES;
	InitCommonControlsEx(&InitCtrls);

	CWinApp::InitInstance();


	AfxEnableControlContainer();

	

	// Create the shell manager, in case the dialog contains
	// any shell tree view or shell list view controls.
	CShellManager *pShellManager = new CShellManager;

	// Activate "Windows Native" visual manager for enabling themes in MFC controls
	CMFCVisualManager::SetDefaultManager(RUNTIME_CLASS(CMFCVisualManagerWindows));

	// Standard initialization
	// If you are not using these features and wish to reduce the size
	// of your final executable, you should remove from the following
	// the specific initialization routines you do not need
	// Change the registry key under which our settings are stored
	// TODO: You should modify this string to be something appropriate
	// such as the name of your company or organization
	SetRegistryKey(_T("Local AppWizard-Generated Applications"));

	CSampleChartDlg dlg;
	m_pMainWnd = &dlg;
	INT_PTR nResponse = dlg.DoModal();
	if (nResponse == IDOK)
	{
		// TODO: Place code here to handle when the dialog is
		//  dismissed with OK
	}
	else if (nResponse == IDCANCEL)
	{
		// TODO: Place code here to handle when the dialog is
		//  dismissed with Cancel
	}
	else if (nResponse == -1)
	{
		TRACE(traceAppMsg, 0, "Warning: dialog creation failed, so application is terminating unexpectedly.\n");
		TRACE(traceAppMsg, 0, "Warning: if you are using MFC controls on the dialog, you cannot #define _AFX_NO_MFC_CONTROLS_IN_DIALOGS.\n");
	}

	// Delete the shell manager created above.
	if (pShellManager != NULL)
	{
		delete pShellManager;
	}

	// Since the dialog has been closed, return FALSE so that we exit the
	//  application, rather than start the application's message pump.
	return FALSE;
}

UINT On_CStGIS_AnalyzerDataThread(LPVOID lp)
{
	
	
	
	return 0;
}

UINT On_CStGIS_GraphDataThread(LPVOID lp)
{

	std::unique_ptr<int> pI{ reinterpret_cast<int*>(lp) };
	int nIndex = *pI;
	CString cs;
	cs.Format(_T("GIS_Test_Complex_%d"),nIndex);

	while (true) {
		{
			std::auto_ptr<CStGIS_AnalyzerData> Packet(new CStGIS_AnalyzerData);


			Packet->m_strTestName = cs;
			Packet->m_strCommandName = "GIS_CREATEANALYZERWINDOW1";
			Packet->m_strTesterID = "Tester#1";

			Packet->m_nSizeInPercentage = 50;
			Packet->m_nTextCount = 0;
			Packet->m_nGraphcount = 2; 

			theApp.m_pMainWnd->PostMessage(MSG_UPDATE_ANALYZER, 0, reinterpret_cast<LPARAM>(Packet.release()));

			::Sleep(5);
		}

	////	{

	////	std::auto_ptr<CStGIS_TextData> Packet(new CStGIS_TextData);

	////	Packet->m_strTestName = cs;
	////	Packet->m_strTesterID = "Tester#1";
	////	Packet->m_strCommandName = "GIS_PLOTTEXTSINGLE";
	////	Packet->m_nSequenceID = 1;
	////	Packet->m_nTextDataType = 0;
	////	Packet->m_nSingleValues = 0;
	////	Packet->m_nUpdateMode = 1;
	////	Packet->m_vec_paramname[0] = "Wafer Number=1, Die number=1";

	////	theApp.m_pMainWnd->PostMessage(MSG_UPDATE_TEXT, 0, reinterpret_cast<LPARAM>(Packet.release()));

	////	::Sleep(5);
	////}

		////for (int i = 1; i <= 5; i++)
		////{

		////	std::auto_ptr<CStGIS_GraphData> Packet(new CStGIS_GraphData);

		////	Packet->m_strTestName = cs;
		////	Packet->m_strTesterID = "Tester#1";
		////	Packet->m_strCommandName = "GIS_SETAXIS";

		////	Packet->m_nSequenceID = i;
		////	Packet->m_nGraphDataType = 0;

		////	CString str("");
		////	str.Format("%s%d", "Point", i);
		////	Packet->m_stObjProp.m_strGraphName = str;
		////	Packet->m_stObjProp.m_strXAxisName = "X";
		////	Packet->m_stObjProp.m_bXScale = false;
		////	Packet->m_stObjProp.m_dXAxisMin = 0;
		////	Packet->m_stObjProp.m_dXAxisMax = 100;
		////	Packet->m_stObjProp.m_bAutoScale = true;
		////	Packet->m_stObjProp.m_strY1AxisName = "Y1";
		////	Packet->m_stObjProp.m_dY1AxisMin = 0;
		////	Packet->m_stObjProp.m_dY1AxisMax = 100;
		////	Packet->m_stObjProp.m_bY1Scale = false;
		////	Packet->m_stObjProp.m_strComment1 = "graph";
		////	Packet->m_stObjProp.m_iUpdateMode = 1;

		////	theApp.m_pMainWnd->PostMessage(MSG_UPDATE_GRAPH, 0, reinterpret_cast<LPARAM>(Packet.release()));

		////	::Sleep(5);
		////}

		////for (int i = 1; i <= 5; i++)
		////{
		////	std::auto_ptr<CStGIS_GraphData> Packet(new CStGIS_GraphData);

		////	Packet->m_strTestName = cs;
		////	Packet->m_strTesterID = "Tester#1";
		////	Packet->m_strCommandName = "GIS_SETLINE";

		////	Packet->m_nSequenceID = i;
		////	Packet->m_nGraphDataType = 2;
		////	Packet->m_stObjLine.m_nXY1LineColor = i - 1;
		////	Packet->m_stObjLine.m_nXY1LineStyle = 1;
		////	Packet->m_stObjLine.m_nXY1LineWidth = 1;
		////	Packet->m_stObjLine.m_nXY1PointColor = 6 - i;
		////	Packet->m_stObjLine.m_nXY1PointSize = 1;
		////	Packet->m_stObjLine.m_nXY1PointStyle = 10;

		////	theApp.m_pMainWnd->PostMessage(MSG_UPDATE_GRAPH, 0, reinterpret_cast<LPARAM>(Packet.release()));

		////	::Sleep(5);
		////}

		////for (int i = 1; i <= 5; i++)
		////{
		////	std::auto_ptr<CStGIS_GraphData> Packet(new CStGIS_GraphData);

		////	Packet->m_strTestName = cs;
		////	Packet->m_strTesterID = "Tester#1";
		////	Packet->m_strCommandName = "GIS_SETAXIS";

		////	CString str("");
		////	str.Format("%s%d", "1DGraph", i);
		////	Packet->m_nSequenceID = i + 5;
		////	Packet->m_nGraphDataType = 1;
		////	Packet->m_stObjProp.m_strGraphName = str;
		////	Packet->m_stObjProp.m_strXAxisName = "X";
		////	Packet->m_stObjProp.m_bXScale = false;
		////	Packet->m_stObjProp.m_dXAxisMin = 0;
		////	Packet->m_stObjProp.m_dXAxisMax = 100;
		////	Packet->m_stObjProp.m_bAutoScale = true;
		////	Packet->m_stObjProp.m_strY1AxisName = "Y1";
		////	Packet->m_stObjProp.m_dY1AxisMin = 0;
		////	Packet->m_stObjProp.m_dY1AxisMax = 100;
		////	Packet->m_stObjProp.m_bY1Scale = false;
		////	Packet->m_stObjProp.m_strComment1 = "Graph";
		////	Packet->m_stObjProp.m_iUpdateMode = 1;

		////	theApp.m_pMainWnd->PostMessage(MSG_UPDATE_GRAPH, 0, reinterpret_cast<LPARAM>(Packet.release()));

		////	::Sleep(5);
		////}

		////for (int i = 1; i <= 5; i++)
		////{
		////	std::auto_ptr<CStGIS_GraphData> Packet(new CStGIS_GraphData);

		////	Packet->m_strTestName = cs;
		////	Packet->m_strTesterID = "Tester#1";
		////	Packet->m_strCommandName = "GIS_SETLINE";

		////	Packet->m_nSequenceID = i + 5;
		////	Packet->m_nGraphDataType = 2;
		////	Packet->m_stObjLine.m_nXY1LineColor = i - 1;
		////	Packet->m_stObjLine.m_nXY1LineStyle = 1;
		////	Packet->m_stObjLine.m_nXY1LineWidth = 1;
		////	Packet->m_stObjLine.m_nXY1PointColor = 6 - i;
		////	Packet->m_stObjLine.m_nXY1PointSize = 1;
		////	Packet->m_stObjLine.m_nXY1PointStyle = 5;

		////	theApp.m_pMainWnd->PostMessage(MSG_UPDATE_GRAPH, 0, reinterpret_cast<LPARAM>(Packet.release()));

		////	::Sleep(5);
		////}

		////for (int i = 1; i <= 5; i++)
		for (int i = 1; i <= 2; i++)
			{
			std::auto_ptr<CStGIS_GraphData> Packet(new CStGIS_GraphData);

			Packet->m_strTestName = cs;
			Packet->m_strTesterID = "Tester#1";

			Packet->m_strCommandName = "GIS_SETAXIS";

			CString csGraphName(_T(""));
			csGraphName.Format(_T("2DGraph%d"), i);

////			Packet->m_nSequenceID = i + 10;
			Packet->m_nSequenceID = i;
			Packet->m_nGraphDataType = 1;
			Packet->m_stObjProp.m_strGraphName = csGraphName;
			Packet->m_stObjProp.m_strXAxisName = "X";
			Packet->m_stObjProp.m_bXScale = false;
			Packet->m_stObjProp.m_dXAxisMin = 0;
			Packet->m_stObjProp.m_dXAxisMax = 100;
			Packet->m_stObjProp.m_bAutoScale = true;
			Packet->m_stObjProp.m_strY1AxisName = "Y1";
			Packet->m_stObjProp.m_dY1AxisMin = 0;
			Packet->m_stObjProp.m_dY1AxisMax = 100;
			Packet->m_stObjProp.m_bY1Scale = false;
			Packet->m_stObjProp.m_strY2AxisName = "Y2";
			Packet->m_stObjProp.m_dY2AxisMin = 0;
			Packet->m_stObjProp.m_dY2AxisMax = 100;
			Packet->m_stObjProp.m_bY2Scale = false;
			Packet->m_stObjProp.m_strComment1 = "Graph";
			Packet->m_stObjProp.m_iUpdateMode = 1;

			theApp.m_pMainWnd->PostMessage(MSG_UPDATE_GRAPH, 0, reinterpret_cast<LPARAM>(Packet.release()));

			::Sleep(5);
		}

		////for (int i = 1; i <= 5; i++)
		for (int i = 1; i <= 2; i++)
			{
			std::auto_ptr<CStGIS_GraphData> Packet(new CStGIS_GraphData);

			Packet->m_strTestName = cs;
			Packet->m_strTesterID = "Tester#1";

			Packet->m_strCommandName = "GIS_SETLINE";

			////Packet->m_nSequenceID = i + 10;
			Packet->m_nSequenceID = i;
			Packet->m_nGraphDataType = 3;
			Packet->m_stObjLine.m_nXY1LineColor = i - 1;
			Packet->m_stObjLine.m_nXY1LineStyle = 1;
			Packet->m_stObjLine.m_nXY1LineWidth = 1;
			Packet->m_stObjLine.m_nXY1PointColor = 6 - i;
			Packet->m_stObjLine.m_nXY1PointSize = 1;
			Packet->m_stObjLine.m_nXY1PointStyle = 14;

			Packet->m_stObjLine.m_nXY2LineColor = i - 1;
			Packet->m_stObjLine.m_nXY2LineStyle = 1;
			Packet->m_stObjLine.m_nXY2LineWidth = 1;
			Packet->m_stObjLine.m_nXY2PointColor = 6 - i;
			Packet->m_stObjLine.m_nXY2PointSize = 1;
			Packet->m_stObjLine.m_nXY2PointStyle = 14;

			theApp.m_pMainWnd->PostMessage(MSG_UPDATE_GRAPH, 0, reinterpret_cast<LPARAM>(Packet.release()));

			::Sleep(5);
		}

		////for (int i = 1; i <= 3; i++)
		////{

		////	std::auto_ptr<CStGIS_GraphData> Packet(new CStGIS_GraphData);

		////	Packet->m_strTestName = cs;
		////	Packet->m_strTesterID = "Tester#1";

		////	Packet->m_strCommandName = "GIS_PLOTGRAPHSINGLE";
		////	Packet->m_nSequenceID = i;
		////	Packet->m_nGraphDataType = 4;
		////	Packet->m_nSequenceID = i;
		////	Packet->m_dXSingleXValue = i;
		////	Packet->m_dXSingleXY1Value = i * 5;
		////	Packet->m_nDataUpdateMode = 0;

		////	theApp.m_pMainWnd->PostMessage(MSG_UPDATE_GRAPH, 0, reinterpret_cast<LPARAM>(Packet.release()));

		////	::Sleep(5);
		////}

		////for (int i = 1; i <= 2; i++)
		////{

		////	std::auto_ptr<CStGIS_GraphData> Packet(new CStGIS_GraphData);

		////	Packet->m_strTestName = cs;
		////	Packet->m_strTesterID = "Tester#1";

		////	Packet->m_strCommandName = "GIS_PLOTGRAPHSINGLE";

		////	Packet->m_nSequenceID = i + 3;
		////	Packet->m_nGraphDataType = 16;
		////	Packet->m_nSequenceID = i + 3;
		////	Packet->m_dXSingleXValue = i + 3;
		////	Packet->m_dXSingleXY1Value = (i + 3) * 5;
		////	Packet->m_nDataUpdateMode = 0;

		////	if (i == 1) {
		////		Packet->m_nXYColor = 0;
		////	}
		////	else {
		////		Packet->m_nXYColor = 2;
		////	}

		////	theApp.m_pMainWnd->PostMessage(MSG_UPDATE_GRAPH, 0, reinterpret_cast<LPARAM>(Packet.release()));

		////	::Sleep(5);

		////}

		Array1D_Double Xarr, Yarr, Y2arr;

		for (int i = 0; i < 26; i++)
		{
			Xarr[i] = 0 + 0.1*i;
		}

		////Yarr[0] = 0.00000000015;
		////Yarr[1] = 0.00000000013;
		////Yarr[2] = 0.00000000018;
		////Yarr[3] = 0.00000000011;
		////Yarr[4] = 0.00000000032;
		////Yarr[5] = 0.00000000009;
		////Yarr[6] = 0;
		////Yarr[7] = 0.00000000001;
		////Yarr[8] = 0.00000000027;
		////Yarr[9] = 0.00000000021;
		////Yarr[10] = 0.00000000017;
		////Yarr[11] = 0.00000000002;
		////Yarr[12] = 0.00000000012;
		////Yarr[13] = 0.0000000001;
		////Yarr[14] = 0.00000000012;
		////Yarr[15] = 0.00000000018;
		////Yarr[16] = 0.0000000002;
		////Yarr[17] = 0.00000000003;
		////Yarr[18] = 0.00000000009;
		////Yarr[19] = 0.00000000023;
		////Yarr[20] = 0.00000000003;
		////Yarr[21] = 0.00000000007;
		////Yarr[22] = 0.00000000038;
		////Yarr[23] = 0.00000000005;
		////Yarr[24] = 0.00000000038;
		////Yarr[25] = 0.00000000011;

		////for (int i = 0; i < 26; i++)
		////{
		////	Y2arr[i] = Yarr[i] * 1.1;
		////}

		////for (int i = 1; i <= 3; i++)
		////{

		////	std::auto_ptr<CStGIS_GraphData> Packet(new CStGIS_GraphData);

		////	Packet->m_strTestName = cs;
		////	Packet->m_strTesterID = "Tester#1";

		////	Packet->m_strCommandName = "GIS_PLOTGRAPH1D";

		////	Packet->m_nSequenceID = i + 5;
		////	Packet->m_nGraphDataType = 6;
		////	Packet->m_nDataUpdateMode = 0;

		////	// TODO need to copy array1D
		////	Packet->m_vec_XAxisValues = Xarr;
		////	Packet->m_vec_Y1AxisValues = Yarr;

		////	theApp.m_pMainWnd->PostMessage(MSG_UPDATE_GRAPH, 0, reinterpret_cast<LPARAM>(Packet.release()));

		////	::Sleep(5);
		////}

		////{

		////	std::auto_ptr<CStGIS_GraphData> Packet(new CStGIS_GraphData);

		////	Packet->m_strTestName = cs;
		////	Packet->m_strTesterID = "Tester#1";

		////	Packet->m_strCommandName = "GIS_PLOTGRAPH1D";

		////	Packet->m_nSequenceID = 9;
		////	Packet->m_nGraphDataType = 18;
		////	Packet->m_nDataUpdateMode = 0;
		////	Packet->m_nXYColor = 1;

		////	Packet->m_vec_XAxisValues = Xarr;
		////	Packet->m_vec_Y1AxisValues = Yarr;

		////	theApp.m_pMainWnd->PostMessage(MSG_UPDATE_GRAPH, 0, reinterpret_cast<LPARAM>(Packet.release()));

		////	::Sleep(5);
		////}


		////{

		////	std::auto_ptr<CStGIS_GraphData> Packet(new CStGIS_GraphData);

		////	Packet->m_strTestName = cs;
		////	Packet->m_strTesterID = "Tester#1";

		////	Packet->m_strCommandName = "GIS_PLOTGRAPH1D";

		////	Packet->m_nSequenceID = 10;
		////	Packet->m_nGraphDataType = 18;
		////	Packet->m_nDataUpdateMode = 0;
		////	Packet->m_nXYColor = 5;

		////	Packet->m_vec_XAxisValues = Xarr;
		////	Packet->m_vec_Y1AxisValues = Yarr;

		////	theApp.m_pMainWnd->PostMessage(MSG_UPDATE_GRAPH, 0, reinterpret_cast<LPARAM>(Packet.release()));

		////	::Sleep(5);
		////}

		Array2D_Double Yarr_2D, Y2arr_2D;
		for (int row = 0; row < 2; row++)
		{
			for (int i = 0; i < 26; i++)
			{
				Yarr_2D[row][i] = Yarr[i] * double(row + 1);
				Y2arr_2D[row][i] = Yarr_2D[row][i] * 0.1;
			}
		}

		////for (int i = 1; i <= 3; i++)
		////	{

		////	std::auto_ptr<CStGIS_GraphData> Packet(new CStGIS_GraphData);

		////	Packet->m_strTestName = cs;
		////	Packet->m_strTesterID = "Tester#1";
		////	Packet->m_strCommandName = "GIS_PLOTGRAPH2D2Y";
		////	Packet->m_nSequenceID = i + 10;
		////	Packet->m_nGraphDataType = 9;
		////	Packet->m_nDataUpdateMode = 0;

		////	Packet->m_vec_XAxisValues = Xarr;
		////	Packet->m_vec_2DY1AxisValues = Yarr_2D;
		////	Packet->m_vec_2DY2AxisValues = Y2arr_2D;

		////	theApp.m_pMainWnd->PostMessage(MSG_UPDATE_GRAPH, 0, reinterpret_cast<LPARAM>(Packet.release()));

		////	::Sleep(5);
		////}

		{
			std::auto_ptr<CStGIS_GraphData> Packet(new CStGIS_GraphData);

			Packet->m_strTestName = cs;
			Packet->m_strTesterID = "Tester#1";
			Packet->m_strCommandName = "GIS_PLOTGRAPH2D2Y";
////			Packet->m_nSequenceID = 14;
			Packet->m_nSequenceID = 1;
			Packet->m_nGraphDataType = 21;
			Packet->m_nDataUpdateMode = 0;
			Packet->m_nXYColor = 0;
			Packet->m_nXY2Color = 1;
			Packet->m_vec_XAxisValues = Xarr;
			Packet->m_vec_2DY1AxisValues = Yarr_2D;
			Packet->m_vec_2DY2AxisValues = Y2arr_2D;

			theApp.m_pMainWnd->PostMessage(MSG_UPDATE_GRAPH, 0, reinterpret_cast<LPARAM>(Packet.release()));
			::Sleep(5);

		}

		{
			std::auto_ptr<CStGIS_GraphData> Packet(new CStGIS_GraphData);

			Packet->m_strTestName = cs;
			Packet->m_strTesterID = "Tester#1";
			Packet->m_strCommandName = "GIS_PLOTGRAPH2D2Y";
			Packet->m_nSequenceID = 2;
////			Packet->m_nSequenceID = 15;
			Packet->m_nGraphDataType = 21;
			Packet->m_nDataUpdateMode = 0;
			Packet->m_nXYColor = 2;
			Packet->m_nXY2Color = 5;
			Packet->m_vec_XAxisValues = Xarr;
			Packet->m_vec_2DY1AxisValues = Yarr_2D;
			Packet->m_vec_2DY2AxisValues = Y2arr_2D;

			theApp.m_pMainWnd->PostMessage(MSG_UPDATE_GRAPH, 0, reinterpret_cast<LPARAM>(Packet.release()));
			::Sleep(5);

		}

		::Sleep(5000);
	}

	return 0;
}


UINT On_CStGIS_TextDataThread(LPVOID lp)
{
	
	
	return 0;
}

void CSampleChartApp::CreateGraphThreads()
{
	for (int i = 1; i <= 10; i++) {
		std::unique_ptr<int> pi{ new int };
		*pi = i;
		AfxBeginThread(On_CStGIS_GraphDataThread, pi.release());
	}
}

