// StAnalyzerDlg.cpp : implementation file
//
#include "StdAfx.h"
#include "SampleChart.h"
////#include "StAnalyzerManager.h"
#include "StAnalyzerDlg.h"
#include <deque>
#include <map>
#include <algorithm>
#include <limits>
#include <float.h>
#include "StGisCommands.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

#define MIN_WINDOWX 350
#define MIN_WINDOWY 350

#define PLOT_6	6
#define PLOT_12	12
#define IDC_TCHART1  501

namespace
{
	bool TestLogPlotSingle1D(CChartWrapper* pCtrlGraph,
		const int nPlot,
		const Array1D_Double &dXAxisValIn,
		const Array1D_Double &dYAxisValIn,
		bool isY2Axis = false)
	{
		if (dXAxisValIn.size() != dYAxisValIn.size())
		{
			//throw std::runtime_error("Unexpected difference in point size for plot data");
		}

		double xmin = (std::numeric_limits<double>::min)();
		double xmax = (std::numeric_limits<double>::max)();

		double ymin = (std::numeric_limits<double>::min)();
		double ymax = (std::numeric_limits<double>::max)();

		try
		{
			pCtrlGraph->GetMinMaxValue1D(dXAxisValIn, dYAxisValIn, xmin, xmax, ymin, ymax);
			////pCtrlGraph->CheckExponentialFormat(nPlot, xmin, xmax, ymin, ymax);
			pCtrlGraph->SetScaleY(nPlot, ymin, ymax);

			pCtrlGraph->PlotLineXvsY1D(nPlot - 1, dXAxisValIn, dYAxisValIn);
			pCtrlGraph->PlotPointXvsY1D(nPlot, dXAxisValIn, dYAxisValIn);
		}
		catch (...)
		{
		}
		return true;


		if (dXAxisValIn.size() != 0)
		{
			pCtrlGraph->GetMinMaxValue1D(dXAxisValIn, dYAxisValIn, xmin, xmax, ymin, ymax);
			////pCtrlGraph->CheckExponentialFormat(nPlot, xmin, xmax, ymin, ymax);
			pCtrlGraph->SetScaleY(nPlot, ymin, ymax);

			pCtrlGraph->PlotLineXvsY1D(nPlot - 1, dXAxisValIn, dYAxisValIn);
			pCtrlGraph->PlotPointXvsY1D(nPlot, dXAxisValIn, dYAxisValIn);
		}

		return (dXAxisValIn.size() != 0);
	}
}

//////////////////////////////////////////////////////////////////////////////////////////////
////
int CStAnalyzerDlg::object_count_ = 0;
const int CStAnalyzerDlg::pad_ = 10;
const int CStAnalyzerDlg::graph_height_ = 150;
const int CStAnalyzerDlg::graph_width_ = 150;
const int CStAnalyzerDlg::max_no_graph_per_row_ = 4;

class SearchPlotData : std::unary_function<std::pair<int, CPlot_Data>, bool>
{
public:
    SearchPlotData(int id);
    bool operator()(std::pair<int, CPlot_Data> plot_pair);

    int lineno;
};
SearchPlotData::SearchPlotData(int id)
{
    lineno = id;
}
bool SearchPlotData::operator()(std::pair<int, CPlot_Data> plot_pair)
{
    return (plot_pair.second.plot_line_id_ == lineno);
}


class SearchPlotByData : public std::unary_function< const CPlot_Data&, bool >
{
	public:
		SearchPlotByData(const CPlot_Data& plot)
			:plot_(plot) {} 
			bool operator()(const CPlot_Data& plot) const;
	private:
	    CPlot_Data plot_;
};

bool SearchPlotByData::operator()(const CPlot_Data& plot) const
{
    return (plot_ == plot);  
}

IMPLEMENT_DYNAMIC(CStAnalyzerDlg, CDialog)
CStAnalyzerDlg::CStAnalyzerDlg(LPCTSTR tzTest, LPCTSTR tzTester, CWnd* pParent /*=NULL*/)
: CDialog(CStAnalyzerDlg::IDD, pParent),
val1_(true),
val2_(true)
{

	this->m_strTest = tzTest;
	m_strTester = tzTester;
	//m_nGraphResourceID = rand()*RESOURCEID_CONSTANT;
	m_nTextResourceID = 200;
	m_nGraphResourceID = IDC_TCHART1;
    ++object_count_;
    text_control_count_ = 0;
    graph_control_count_ = 0;
	last_plot_id_ = -1;
	prev_xy_color_ = -1;
	prev_xy2_color_ = -1;
}

//////////////////////////////////////////////////////////////////////////////////////////////
////

CStAnalyzerDlg::~CStAnalyzerDlg()
{
	TRACE("\nDestroying CStAnalyzerDlg\n");
}

//////////////////////////////////////////////////////////////////////////////////////////////
////

void CStAnalyzerDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

//////////////////////////////////////////////////////////////////////////////////////////////
////

BEGIN_MESSAGE_MAP(CStAnalyzerDlg, CDialog)

	ON_WM_CLOSE()
	ON_WM_CTLCOLOR()
	
    ON_WM_SIZE()
	ON_WM_DESTROY()
	ON_WM_GETMINMAXINFO()

	ON_MESSAGE(UWM_RESET_DLG_CONTENT,OnResetDlgContent)
	ON_MESSAGE(UWM_ENABLE_MENU_ITEM,OnEnableMenuItem)
	ON_MESSAGE(UWM_PLOT_GIS_TEXT,OnPlotGISText)
	ON_MESSAGE(UWM_CALL_GRAPH_FUNCTION,OnCallGraphFunction)
	ON_MESSAGE(UWM_CREATE_SUB_WINDOW, OnCreateSubWindow)
	ON_MESSAGE(UWM_SET_CLOSE_MODE, OnSetCloseMode)
	ON_MESSAGE(UWM_SET_CLOSE_MODE, OnSetDialogMenu)	
	ON_WM_EXITSIZEMOVE()
END_MESSAGE_MAP()

//////////////////////////////////////////////////////////////////////////////////////////////
////

LRESULT CStAnalyzerDlg::OnCallGraphFunction(WPARAM wParam, LPARAM lParam)
{
	int nCommandID{ static_cast<int>(wParam) };

	std::auto_ptr<CStGIS_GraphData> pData{ reinterpret_cast<CStGIS_GraphData*>(lParam) };

	std::auto_ptr<CPlotGraphInfo> pPlotInfo{ new CPlotGraphInfo };

	switch (nCommandID)
	{

		case GIS_CLEARDATA:
			break;

		case GIS_SETAXIS:
		{
			pPlotInfo->gis_cmd_ = GIS_SETAXIS;
			pPlotInfo->nSequenceID_ = pData->m_nSequenceID;
			pPlotInfo->stObjProp_ = pData->m_stObjProp;
			pPlotInfo->nGraphDataType_ = pData->m_nGraphDataType;
		}
			break;

		case GIS_SETLINE:
		{
			pPlotInfo->gis_cmd_ = GIS_SETLINE;
			pPlotInfo->nSequenceID_ = pData->m_nSequenceID;
			pPlotInfo->stObjLine_ = pData->m_stObjLine;
			pPlotInfo->nGraphDataType_ = pData->m_nGraphDataType;
		}
			break;

		case GIS_PLOTGRAPH2D2Y:
		{
			pPlotInfo->gis_cmd_ = GIS_PLOTGRAPH2D2Y;
			pPlotInfo->nSequenceID_ = pData->m_nSequenceID;
			pPlotInfo->nGraphDataType_ = pData->m_nGraphDataType;

			if (pData->m_nGraphDataType == 15)
			{
				pPlotInfo->vec_XAxisValues_.swap(pData->m_vec_XAxisValues);
				pPlotInfo->vec_2DY1AxisValues_.swap(pData->m_vec_2DY1AxisValues);
				pPlotInfo->vec_2DY2AxisValues_.swap(pData->m_vec_2DY2AxisValues);
				pPlotInfo->nLineColor_ = pData->m_nLineColor;
				pPlotInfo->nLine2Color_ = pData->m_nLine2Color;
				pPlotInfo->nDataUpdateMode_ = pData->m_nDataUpdateMode;
			}
			else if (pData->m_nGraphDataType == 21)
			{
				pPlotInfo->vec_XAxisValues_.swap(pData->m_vec_XAxisValues);
				pPlotInfo->vec_2DY1AxisValues_.swap(pData->m_vec_2DY1AxisValues);
				pPlotInfo->vec_2DY2AxisValues_.swap(pData->m_vec_2DY2AxisValues);
				pPlotInfo->nXYColor_ = pData->m_nXYColor;
				pPlotInfo->nXY2Color_ = pData->m_nXY2Color;
				pPlotInfo->nDataUpdateMode_ = pData->m_nDataUpdateMode;
			}
			else
			{
				pPlotInfo->vec_XAxisValues_.swap(pData->m_vec_XAxisValues);
				pPlotInfo->vec_2DY1AxisValues_.swap(pData->m_vec_2DY1AxisValues);
				pPlotInfo->vec_2DY2AxisValues_.swap(pData->m_vec_2DY2AxisValues);
				pPlotInfo->nDataUpdateMode_ = pData->m_nDataUpdateMode;
			}
		}
			break;

		default:
			break;
	}

	switch (pPlotInfo->gis_cmd_)
	{
		case GIS_CLEARDATA:
			break;

		case GIS_SETAXIS:
		{
			SetAxis(pPlotInfo->nSequenceID_, pPlotInfo->stObjProp_, pPlotInfo->nGraphDataType_);
		}
		break;

		case GIS_SETLINE:
		{
			SetLine(pPlotInfo->nSequenceID_, pPlotInfo->stObjLine_, pPlotInfo->nGraphDataType_);			
		}
		break;

		case GIS_PLOTGRAPH2D2Y:
		{								
			Plot_graph_pclr(pPlotInfo->nSequenceID_, pPlotInfo->vec_XAxisValues_, pPlotInfo->vec_2DY1AxisValues_, pPlotInfo->vec_2DY2AxisValues_, pPlotInfo->nXYColor_, pPlotInfo->nXY2Color_, pPlotInfo->nDataUpdateMode_);
		}
		break;

		default:
			break;
	}

	return 0L;
}

LRESULT CStAnalyzerDlg::OnPlotGISText(WPARAM wParam, LPARAM lParam)
{
	int nCommandID{ static_cast<int>(wParam) };

	std::auto_ptr<CStGIS_TextData> pData{ reinterpret_cast<CStGIS_TextData*>(lParam) };

	std::auto_ptr<CPlotTextInfo> pPlotInfo(new CPlotTextInfo);

	return 0L;
}

LRESULT CStAnalyzerDlg::OnResetDlgContent(WPARAM wParam, LPARAM lParam)
{
	std::unique_ptr<std::pair<int, int>> pr{ reinterpret_cast<std::pair<int, int> *>(lParam) };

	ResetDialogContent();

	return 0L;
}

LRESULT CStAnalyzerDlg::OnEnableMenuItem(WPARAM wparam, LPARAM lparam)
{
	UINT param1 = static_cast<UINT>(wparam);
	UINT param2 = static_cast<UINT>(lparam);

	CMenu* mnu = GetSystemMenu(FALSE);
	mnu->EnableMenuItem( param1, param2);
	return 0L;
}

BOOL CStAnalyzerDlg::OnInitDialog()
{
	CDialog::OnInitDialog();
	
	CString strTime, strText;
	GetTime(strTime);

	count_plot_line_ = 0;
	is_force_close_ = false;

	return FALSE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}

//////////////////////////////////////////////////////////////////////////////////////////////
////

LRESULT CStAnalyzerDlg::OnSetCloseMode(WPARAM, LPARAM lparam)
{
	is_force_close_ = static_cast<bool>(lparam);
	return 0L;
}

LRESULT CStAnalyzerDlg::OnSetDialogMenu(WPARAM /*wParam*/, LPARAM lParam)
{
	int nButtonClose = static_cast<int>(lParam); 
	if (nButtonClose == 0)
	{
		CMenu* mnu = GetSystemMenu(FALSE);
		mnu->EnableMenuItem(SC_CLOSE, MF_BYCOMMAND | MF_GRAYED);
		SendMessage(UWM_ENABLE_MENU_ITEM, (WPARAM)SC_CLOSE, (LPARAM)MF_BYCOMMAND | MF_GRAYED);
	}
	if (nButtonClose == 1)
	{
		CMenu* mnu = GetSystemMenu(FALSE);
		mnu->EnableMenuItem(SC_CLOSE, MF_BYCOMMAND | MF_ENABLED);
		SendMessage(UWM_ENABLE_MENU_ITEM, (WPARAM)SC_CLOSE, (LPARAM)MF_BYCOMMAND | MF_ENABLED);
	}

	return 0L;
}


void CStAnalyzerDlg::OnClose()
{
	if (is_force_close_ == true)
	{
		--object_count_;
		DestroyWindow();
		return;
	}

	std::auto_ptr<std::pair<std::string, std::string> > pPair(new std::pair<std::string, std::string>);
	pPair->first = std::string(m_strTest);
	pPair->second = std::string(m_strTester);
   	--object_count_;
	DestroyWindow();
}


///////////////////////////////////////////////////////////////////////////////////////////////////////
//

void CStAnalyzerDlg::GetTime(CString& strTime)
{
	CTime theTime;
	theTime = CTime::GetCurrentTime();
	strTime = theTime.Format("%Y%b%d %H:%M:%S");

}

nsSTAr::nsChartDataType::enChartLineStyle CStAnalyzerDlg::GetLineStyle(const int nLineStyle)
{
	return nsSTAr::nsChartDataType::LineSolid;
}

///////////////////////////////////////////////////////////////////////////////////////////////////////
//

nsSTAr::nsChartDataType::enChartPointStyle CStAnalyzerDlg::GetPointStyle(const int nPointStyle)
{
	return nsSTAr::nsChartDataType::PointBoldX;
}

COLORREF CStAnalyzerDlg::GetColor(int nColor)
{
    int nColorIndex = ((nColor >= 0) && (nColor <= 12)) ? nColor : 13;

    static COLORREF arr_color[14] = {
        RGB(255,0,0),
        RGB(0,255,0),
        RGB(0,0,255),
        RGB(0,0,0),
        RGB(255,127,0),
        RGB(255,255,125),
        RGB(0,0,160),
        RGB(128,0,255),
        RGB(192,192,192),
        RGB(64,0,128),
        RGB(255,0,255),
		RGB(255,128,192),
        RGB(0,255,255),
        // default
        RGB(255,0, 255)

    };

    return arr_color[nColorIndex];	
}

void CStAnalyzerDlg::PostNcDestroy()
{
	CDialog::PostNcDestroy();
	
}

void CStAnalyzerDlg::OnGetMinMaxInfo(MINMAXINFO* lpMMI)
{
	// TODO: Add your message handler code here and/or call default
	lpMMI->ptMinTrackSize.x = MIN_WINDOWX;
	lpMMI->ptMinTrackSize.y = MIN_WINDOWY;
	CDialog::OnGetMinMaxInfo(lpMMI);
}


void CStAnalyzerDlg::OnDestroy()
{
	for(std::map<int, CEdit*>::iterator itr = m_aMapTxtWndToSequence.begin();
									   itr != m_aMapTxtWndToSequence.end();
									   ++itr)
	{
		itr->second->DestroyWindow();
		delete itr->second;
	}
	m_aMapTxtWndToSequence.clear();

	for(std::vector<HFONT>::iterator itr = vec_font_.begin();
									itr != vec_font_.end();
									++itr)
	{
		DeleteObject(*itr);
	}
	vec_font_.clear();

	for(std::map<int, CChartWrapper*>::iterator itr = m_aMapGrpWndToSequence.begin();
												itr != m_aMapGrpWndToSequence.end();
												++itr)
	{
		itr->second->RemoveAllPlots();
		itr->second->ClearData();
		itr->second->DestroyChartWindow();
		delete itr->second;
		m_nGraphResourceID--;
	}
	m_aMapGrpWndToSequence.clear();

	CDialog::OnDestroy();
}

void CStAnalyzerDlg::ResetDialogContent()
{
	map_line_prop_.clear();
	map_plots.clear();
	is_force_close_ = false;

	for(std::map<int, CEdit*>::iterator itr = m_aMapTxtWndToSequence.begin();
									   itr != m_aMapTxtWndToSequence.end();
									   ++itr)
	{
		itr->second->SetWindowText("");
	}

	COLORREF color = RGB(255, 255, 255);
	COLORREF frameColor = RGB(225, 225, 225);

	for(std::map<int, CChartWrapper*>::iterator itr = m_aMapGrpWndToSequence.begin();
												itr != m_aMapGrpWndToSequence.end();
												++itr)
	{

		itr->second->RemoveAllPlots();

		itr->second->AddLinePointPlotEx(_T(""), 1);
		itr->second->SetTChartProperty();

		itr->second->SetFrameStyle(CChartWrapper::EN_FRAME_CLASSIC);
		itr->second->SetFrameColor(frameColor);

		itr->second->SetAxisTicks(CChartWrapper::EN_AXIS_HORIZONTAL_BOTTOM);
		itr->second->SetAxisTicks(CChartWrapper::EN_AXIS_VERTICAL_LEFT);

		itr->second->SetPlotAreaColor(color);
	}

	//text_control_count_ = 0;
    //graph_control_count_ = 0;
	last_plot_id_ = -1;
	prev_xy_color_ = -1;
	prev_xy2_color_ = -1;

	curr_line_prop_.m_nXY1LineWidth  = 1;
	curr_line_prop_.m_nXY1PointStyle = 10;
	curr_line_prop_.m_nXY1PointColor = 1;
	curr_line_prop_.m_nXY2LineWidth  = 1;
	curr_line_prop_.m_nXY2PointStyle = 10;
	curr_line_prop_.m_nXY2PointColor = 1;
}

LRESULT CStAnalyzerDlg::OnCreateSubWindow(WPARAM wparam, LPARAM lparam)
{
	bool *status = reinterpret_cast<bool *>(wparam);
	std::pair<int, int> *pr(reinterpret_cast<std::pair<int, int> *>(lparam));
	*status = CreateSubWindow(pr->first, pr->second);

	return 0L;
}

bool CStAnalyzerDlg::CreateSubWindow(int nTextWindow, int nGraphWindow)
{
	int m_nWndCount = 0;
	m_nWndCount = nTextWindow + nGraphWindow;

	if(m_nWndCount > 16)
	{
		return false;
	}
	
    std::vector<CRect> pRect;
    CRect clientrect;

    if(GetSafeHwnd() != NULL)
	{
		GetClientRect(&clientrect);
		clientrect.NormalizeRect();
		clientrect.top = pad_;
		clientrect.left = pad_;
		clientrect.bottom = clientrect.bottom - pad_;
		clientrect.right = clientrect.right - pad_;
        GetDimensions(pRect,clientrect);
    }

	//// First create text window
	for(int n = 0; n < nTextWindow;n++)
	{
		LOGFONT lf = {0};
		lf.lfHeight = -MulDiv( 9, 96, 72);
		strcpy(lf.lfFaceName, "Arial" );
		// Create font.
		HFONT hFont = ::CreateFontIndirect( &lf );
	   
		CEdit* pTextWnd = new CEdit();
		pTextWnd->Create(WS_CHILD | WS_VISIBLE | WS_BORDER | WS_HSCROLL | WS_VSCROLL | ES_MULTILINE | ES_READONLY | ES_AUTOHSCROLL | ES_AUTOVSCROLL, pRect[n], this, m_nTextResourceID++);
				
		// Set font.
		pTextWnd->SendMessage(WM_SETFONT, (WPARAM) hFont);
		m_aMapTxtWndToSequence.insert(std::make_pair(n,pTextWnd));
		vec_font_.push_back(hFont);
	}

	COLORREF color = RGB(255,255,255);
	COLORREF frameColor = RGB(225, 225, 225);

	int nGraphCount = nTextWindow + nGraphWindow;
	for (int n = 0; nTextWindow < nGraphCount; nTextWindow++, n++, m_nGraphResourceID++)
	{			
		CChartWrapper* pCtrlGraph = new CChartWrapper();
		pCtrlGraph->CreateTChart(pRect[nTextWindow], this, m_nGraphResourceID);
		pCtrlGraph->SetTChartProperty();
		pCtrlGraph->SetFrameStyle(CChartWrapper::EN_FRAME_CLASSIC);
		pCtrlGraph->SetFrameColor(frameColor);

		pCtrlGraph->AddLinePointPlotEx(_T(""), 1);
		//end air		

		CFont *font = new CFont();
		font->CreateFont(9, 0, 0, 0, 120, 0, 0, 0, 0, 0, 0, 0, 0, "arial");
		pCtrlGraph->SetFont(font);		

		for (int j = 1; j < 3; j++)
		{
			if (j == 1)
				pCtrlGraph->SetAxisTicks(CChartWrapper::EN_AXIS_HORIZONTAL_BOTTOM);
			if (j == 2)
				pCtrlGraph->SetAxisTicks(CChartWrapper::EN_AXIS_VERTICAL_LEFT);
		}

		pCtrlGraph->SetPlotAreaColor(color);
		m_aMapGrpWndToSequence.insert(std::make_pair(n, pCtrlGraph));

		//position the NIGraph
		pCtrlGraph->SetWindowPos(0, pRect[nTextWindow].left, pRect[nTextWindow].top, pRect[nTextWindow].Width(), pRect[nTextWindow].Height(), SWP_NOZORDER | SWP_SHOWWINDOW);
	}

	curr_line_prop_.m_nXY1LineWidth  = 1;
	curr_line_prop_.m_nXY1PointStyle = 10;
	curr_line_prop_.m_nXY1PointColor = 1;
	curr_line_prop_.m_nXY2LineWidth  = 1;
	curr_line_prop_.m_nXY2PointStyle = 10;
	curr_line_prop_.m_nXY2PointColor = 1;
	
	return true;
}

///////////////////////////////////////////////////////////////////////////////////////////////////////
//

CChartWrapper* CStAnalyzerDlg::GetGraphWnd(int nSequence)
{
	std::map<int, CChartWrapper*>::iterator itr = m_aMapGrpWndToSequence.find(nSequence);
	if(itr != m_aMapGrpWndToSequence.end())
		return itr->second;


	return NULL;
}

///////////////////////////////////////////////////////////////////////////////////////////////////////
//

CEdit* CStAnalyzerDlg::GetTxtWnd(int nSequence)
{
	std::map<int, CEdit*>::iterator itr = m_aMapTxtWndToSequence.find(nSequence);
	if(itr != m_aMapTxtWndToSequence.end())
		return itr->second;

	return NULL;
}


///////////////////////////////////////////////////////////////////////////////////////////////////////
//

void CStAnalyzerDlg::CloseSubWindow(int nSequence)
{


}

///////////////////////////////////////////////////////////////////////////////////////////////////////
//
void CStAnalyzerDlg::ClearAllData()
{


}

///////////////////////////////////////////////////////////////////////////////////////////////////////
//

void CStAnalyzerDlg::ClearData(int nSequence)
{


}

///////////////////////////////////////////////////////////////////////////////////////////////////////
//

void CStAnalyzerDlg::RefreshAllWindow()
{


}

///////////////////////////////////////////////////////////////////////////////////////////////////////
//

void CStAnalyzerDlg::RefreshWindow(int nSequence)
{


}

///////////////////////////////////////////////////////////////////////////////////////////////////////
//
void CStAnalyzerDlg::SetAxis(int nSequence, CStAxisProperty& stAxisProp)
{
	// Get the graph window based on the sequence number 
	CChartWrapper* pCtrlGraph = 0;
    int graph_sequence = nSequence;
	pCtrlGraph = this->GetGraphWnd(--nSequence);

	if(pCtrlGraph == 0)
	    return;

	pCtrlGraph->RemoveAllPlots();

	int nPlot;

	if (stAxisProp.m_iUpdateMode == 0)
	if (pCtrlGraph->GetAxesCount() == 3)
		pCtrlGraph->RemoveAxis(CChartWrapper::EN_AXIS_VERTICAL_RIGHT);

	nPlot = pCtrlGraph->AddLinePointPlotEx(_T(""), 1);

	COLORREF nColor = RGB(33,0,64);
	pCtrlGraph->SetCaption(stAxisProp.m_strGraphName.c_str(), nColor);		   
	pCtrlGraph->SetAxisTitle(CChartWrapper::EN_AXIS_HORIZONTAL_BOTTOM, stAxisProp.m_strXAxisName.c_str());
	pCtrlGraph->SetAxisVisible(CChartWrapper::EN_AXIS_HORIZONTAL_BOTTOM, true);
	pCtrlGraph->SetAxisTitle(CChartWrapper::EN_AXIS_VERTICAL_LEFT, stAxisProp.m_strY1AxisName.c_str());
	pCtrlGraph->SetAxisVisible(CChartWrapper::EN_AXIS_VERTICAL_LEFT, true);
	pCtrlGraph->SetAxisLog(CChartWrapper::EN_AXIS_HORIZONTAL_BOTTOM, stAxisProp.m_bXScale);
	pCtrlGraph->SetAxisLog(CChartWrapper::EN_AXIS_VERTICAL_LEFT, stAxisProp.m_bY1Scale);
	pCtrlGraph->SetAxisAutoscale(CChartWrapper::EN_AXIS_HORIZONTAL_BOTTOM, stAxisProp.m_bAutoScale);
	pCtrlGraph->SetAxisAutoscale(CChartWrapper::EN_AXIS_VERTICAL_LEFT, stAxisProp.m_bAutoScale);

	if (!stAxisProp.m_bAutoScale)
	{
		pCtrlGraph->SetRange(CChartWrapper::EN_AXIS_HORIZONTAL_BOTTOM, stAxisProp.m_dXAxisMin, stAxisProp.m_dXAxisMax);
		CTChartLabels label;
		double x = 0;
		if (stAxisProp.m_dXAxisMax <= 1)
		{

			CXTChartLabels label1;
			x = stAxisProp.m_dXAxisMax / 5;

			label1.x1_ = stAxisProp.m_dXAxisMin;
			label.XLabels.push_back(label1);
			label1.x1_ = stAxisProp.m_dXAxisMin + x;
			label.XLabels.push_back(label1);
			label1.x1_ = stAxisProp.m_dXAxisMin + 2 * x;
			label.XLabels.push_back(label1);
			label1.x1_ = stAxisProp.m_dXAxisMin + 3 * x;
			label.XLabels.push_back(label1);
			label1.x1_ = stAxisProp.m_dXAxisMin + 4 * x;
			label.XLabels.push_back(label1);
			label1.x1_ = stAxisProp.m_dXAxisMax;
			label.XLabels.push_back(label1);

		}
		pCtrlGraph->SetRange(CChartWrapper::EN_AXIS_VERTICAL_LEFT, stAxisProp.m_dY1AxisMin, stAxisProp.m_dY1AxisMax);

		if (stAxisProp.m_dY1AxisMax <= 1)
		{

			CY1TChartLabels label1;
			x = stAxisProp.m_dY1AxisMax / 5;

			label1.x1_ = stAxisProp.m_dY1AxisMin;
			label.Y1Labels.push_back(label1);
			label1.x1_ = stAxisProp.m_dY1AxisMin + x;
			label.Y1Labels.push_back(label1);
			label1.x1_ = stAxisProp.m_dY1AxisMin + 2 * x;
			label.Y1Labels.push_back(label1);
			label1.x1_ = stAxisProp.m_dY1AxisMin + 3 * x;
			label.Y1Labels.push_back(label1);
			label1.x1_ = stAxisProp.m_dY1AxisMin + 4 * x;
			label.Y1Labels.push_back(label1);
			label1.x1_ = stAxisProp.m_dY1AxisMax;
			label.Y1Labels.push_back(label1);

		}
		map_label_.insert(std::make_pair((nSequence + 1), label));
	}

	pCtrlGraph->SetAxisTicks(CChartWrapper::EN_AXIS_HORIZONTAL_BOTTOM);
	pCtrlGraph->SetAxisTicks(CChartWrapper::EN_AXIS_VERTICAL_LEFT);

	if (last_seq_ == graph_sequence)
	{
		if (curr_line_prop_.m_nXY1LineColor != -1 || curr_line_prop_.m_nXY1LineStyle != -1
			|| curr_line_prop_.m_nXY1LineWidth != -1
			|| curr_line_prop_.m_nXY1PointColor != -1
			|| curr_line_prop_.m_nXY1PointSize != -1
			|| curr_line_prop_.m_nXY1PointStyle != -1
			|| curr_line_prop_.m_nXY2LineColor != -1
			|| curr_line_prop_.m_nXY2LineStyle != -1
			|| curr_line_prop_.m_nXY2LineWidth != -1
			|| curr_line_prop_.m_nXY2PointColor != -1
			|| curr_line_prop_.m_nXY2PointSize != -1
			|| curr_line_prop_.m_nXY2PointStyle != -1)
		{
			SetLine(graph_sequence, curr_line_prop_, 2);
		}
	}
}

///////////////////////////////////////////////////////////////////////////////////////////////////////
//
void CStAnalyzerDlg::SetAxis(int nSequence, CStAxisProperty& stAxisProp, int nAxis)
{
	//int nPlot;
	int graph_sequence = nSequence;

	if (this->GetGraphWnd(nSequence - 1) == NULL)
		return;

	std::map<int, CGraphAxisInfo>::iterator map_iter = map_axisinfo_.find(nSequence + 1);
	if (map_iter != map_axisinfo_.end())
	{
		map_axisinfo_.erase(map_iter);
	}

	CGraphAxisInfo info;
	info.countX_ = 1;
	info.countY1_ = 1;
	info.countY2_ = 1;
	info.lastLabelX_ = 0;
	info.lastLabelY1_ = 0;
	info.lastLabelY2_ = 0;

	map_axisinfo_.insert(std::make_pair(nSequence, info));

	if (nAxis == 0)
	{
		SetAxis(nSequence, stAxisProp);
		return;
	}
	else
	{
		CChartWrapper* pCtrlGraph = 0;
		pCtrlGraph = this->GetGraphWnd(--nSequence);

		pCtrlGraph->RemoveAllPlots();

		pCtrlGraph->AddLinePointPlotEx(_T(""), 1);
		pCtrlGraph->AddLinePointPlotEx(_T(""), 1, 1);

		pCtrlGraph->SetAxisTicks(CChartWrapper::EN_AXIS_VERTICAL_RIGHT);


		COLORREF nColor = RGB(33, 0, 64);
		pCtrlGraph->SetCaption(stAxisProp.m_strGraphName.c_str(), nColor);

		pCtrlGraph->SetAxisTitle(CChartWrapper::EN_AXIS_HORIZONTAL_BOTTOM, stAxisProp.m_strXAxisName.c_str());
		pCtrlGraph->SetAxisVisible(CChartWrapper::EN_AXIS_HORIZONTAL_BOTTOM, true);


		pCtrlGraph->SetAxisTitle(CChartWrapper::EN_AXIS_VERTICAL_LEFT, stAxisProp.m_strY1AxisName.c_str());
		pCtrlGraph->SetAxisVisible(CChartWrapper::EN_AXIS_VERTICAL_LEFT, true);
		pCtrlGraph->SetAxisTitle(CChartWrapper::EN_AXIS_VERTICAL_RIGHT, stAxisProp.m_strY2AxisName.c_str());
		pCtrlGraph->SetAxisVisible(CChartWrapper::EN_AXIS_VERTICAL_RIGHT, true);
		pCtrlGraph->SetAxisLog(CChartWrapper::EN_AXIS_HORIZONTAL_BOTTOM, stAxisProp.m_bXScale);
		pCtrlGraph->SetAxisLog(CChartWrapper::EN_AXIS_VERTICAL_LEFT, stAxisProp.m_bY1Scale);
		pCtrlGraph->SetAxisLog(CChartWrapper::EN_AXIS_VERTICAL_RIGHT, stAxisProp.m_bY2Scale);
		pCtrlGraph->SetAxisAutoscale(CChartWrapper::EN_AXIS_HORIZONTAL_BOTTOM, stAxisProp.m_bAutoScale);
		pCtrlGraph->SetAxisAutoscale(CChartWrapper::EN_AXIS_VERTICAL_LEFT, stAxisProp.m_bAutoScale);
		pCtrlGraph->SetAxisAutoscale(CChartWrapper::EN_AXIS_VERTICAL_RIGHT, stAxisProp.m_bAutoScale);

		if (!stAxisProp.m_bAutoScale)
		{

			pCtrlGraph->SetRange(CChartWrapper::EN_AXIS_HORIZONTAL_BOTTOM, stAxisProp.m_dXAxisMin, stAxisProp.m_dXAxisMax);

			pCtrlGraph->SetRange(CChartWrapper::EN_AXIS_VERTICAL_LEFT, stAxisProp.m_dY1AxisMin, stAxisProp.m_dY1AxisMax);
			CTChartLabels label;
			double x = 0;
			if (stAxisProp.m_dY1AxisMax <= 1)
			{

				CY1TChartLabels label1;
				x = stAxisProp.m_dY1AxisMax / 5;

				label1.x1_ = stAxisProp.m_dY1AxisMin;
				label.Y1Labels.push_back(label1);
				label1.x1_ = stAxisProp.m_dY1AxisMin + x;
				label.Y1Labels.push_back(label1);
				label1.x1_ = stAxisProp.m_dY1AxisMin + 2 * x;
				label.Y1Labels.push_back(label1);
				label1.x1_ = stAxisProp.m_dY1AxisMin + 3 * x;
				label.Y1Labels.push_back(label1);
				label1.x1_ = stAxisProp.m_dY1AxisMin + 4 * x;
				label.Y1Labels.push_back(label1);
				label1.x1_ = stAxisProp.m_dY1AxisMax;
				label.Y1Labels.push_back(label1);

			}

			pCtrlGraph->SetRange(CChartWrapper::EN_AXIS_VERTICAL_RIGHT, stAxisProp.m_dY2AxisMin, stAxisProp.m_dY2AxisMax);
			if (stAxisProp.m_dY2AxisMax <= 1)
			{
				CY2TChartLabels label2;
				x = stAxisProp.m_dY2AxisMax / 5;

				label2.x1_ = stAxisProp.m_dY2AxisMin;
				label.Y2Labels.push_back(label2);
				label2.x1_ = stAxisProp.m_dY2AxisMin + x;
				label.Y2Labels.push_back(label2);
				label2.x1_ = stAxisProp.m_dY2AxisMin + 2 * x;
				label.Y2Labels.push_back(label2);
				label2.x1_ = stAxisProp.m_dY2AxisMin + 3 * x;
				label.Y2Labels.push_back(label2);
				label2.x1_ = stAxisProp.m_dY2AxisMin + 4 * x;
				label.Y2Labels.push_back(label2);
				label2.x1_ = stAxisProp.m_dY2AxisMax;
				label.Y2Labels.push_back(label2);

			}
			map_label_.insert(std::make_pair((nSequence + 1), label));

		}


		if (last_seq_ == graph_sequence)
		{
			if (curr_line_prop_.m_nXY1LineColor != -1 && curr_line_prop_.m_nXY1LineStyle != -1
				|| curr_line_prop_.m_nXY1LineWidth != -1
				|| curr_line_prop_.m_nXY1PointColor != -1
				|| curr_line_prop_.m_nXY1PointSize != -1
				|| curr_line_prop_.m_nXY1PointStyle != -1
				|| curr_line_prop_.m_nXY2LineColor != -1
				|| curr_line_prop_.m_nXY2LineStyle != -1
				|| curr_line_prop_.m_nXY2LineWidth != -1
				|| curr_line_prop_.m_nXY2PointColor != -1
				|| curr_line_prop_.m_nXY2PointSize != -1
				|| curr_line_prop_.m_nXY2PointStyle != -1)
			{
				SetLine(graph_sequence, curr_line_prop_, nAxis);
			}
		}
	}

}

///////////////////////////////////////////////////////////////////////////////////////////////////////
// set the line property	

void CStAnalyzerDlg::SetLine(int nSequence, CStLineProperty& stLineProp, int nAxis)
{
	// Get the graph window based on the sequence number 
	if (this->GetGraphWnd(nSequence - 1) == NULL)
		return;

	count_plot_line_++;
	CChartWrapper* pCtrlGraph = 0;
	int graph_sequence = nSequence;
	pCtrlGraph = this->GetGraphWnd(--nSequence);

	if (pCtrlGraph == 0)
		return;
	// Single - Y axis for single , 1D & 2D data 
	if (nAxis == 2)
	{
		// set the style the use want to see in the graph :
		int nPlot = pCtrlGraph->GetLinePointPlotCount();

		pCtrlGraph->SetPlotLineWidth(nPlot - 1, stLineProp.m_nXY1LineWidth);
		pCtrlGraph->SetPlotLineStyle(nPlot - 1, GetLineStyle(stLineProp.m_nXY1LineStyle));
		pCtrlGraph->SetPlotLineColor(nPlot - 1, GetColor(stLineProp.m_nXY1LineColor));

		pCtrlGraph->SetPlotPointStyle(nPlot, this->GetPointStyle(stLineProp.m_nXY1PointStyle));
		pCtrlGraph->SetPlotPointColor(nPlot, GetColor(stLineProp.m_nXY1PointColor));
		pCtrlGraph->SetAxisLabelColor(CChartWrapper::EN_AXIS_VERTICAL_LEFT, RGB(33, 0, 64));
		pCtrlGraph->SetAxisMajorTickColor(CChartWrapper::EN_AXIS_VERTICAL_LEFT, RGB(33, 0, 64));
	}
	else if (nAxis == 3)
	{
		int nPlot = pCtrlGraph->GetLinePointPlotCount();
		pCtrlGraph->SetPlotLineWidth(nPlot - 4, stLineProp.m_nXY1LineWidth);
		pCtrlGraph->SetPlotLineStyle(nPlot - 4, GetLineStyle(stLineProp.m_nXY1LineStyle));
		pCtrlGraph->SetPlotLineColor(nPlot - 4, GetColor(stLineProp.m_nXY1LineColor));

		pCtrlGraph->SetPlotPointStyle(nPlot - 3, this->GetPointStyle(stLineProp.m_nXY1PointStyle));
		pCtrlGraph->SetPlotPointColor(nPlot - 3, this->GetColor(stLineProp.m_nXY1PointColor));

		COLORREF nColor = RGB(33, 0, 64);
		pCtrlGraph->SetAxisLabelColor(CChartWrapper::EN_AXIS_VERTICAL_LEFT, nColor);
		pCtrlGraph->SetAxisMajorTickColor(CChartWrapper::EN_AXIS_VERTICAL_LEFT, nColor);
		pCtrlGraph->SetPlotLineWidth(nPlot - 1, stLineProp.m_nXY2LineWidth);
		pCtrlGraph->SetPlotLineStyle(nPlot - 1, GetLineStyle(stLineProp.m_nXY2LineStyle));
		pCtrlGraph->SetPlotLineColor(nPlot - 1, GetColor(stLineProp.m_nXY2LineColor));

		pCtrlGraph->SetPlotPointStyle(nPlot, this->GetPointStyle(stLineProp.m_nXY2PointStyle));
		pCtrlGraph->SetPlotPointColor(nPlot, this->GetColor(stLineProp.m_nXY2PointColor));
		pCtrlGraph->SetAxisLabelColor(CChartWrapper::EN_AXIS_VERTICAL_RIGHT, nColor);
		pCtrlGraph->SetAxisMajorTickColor(CChartWrapper::EN_AXIS_VERTICAL_RIGHT, nColor);
	}

	std::deque<std::pair<int, CPlot_Data> > temp;
	std::deque<std::pair<int, CPlot_Data> >().swap(temp);

	// storing the line and point property
	curr_line_prop_ = stLineProp;

	map_line_prop_.erase(graph_sequence);

	map_line_prop_.insert(std::make_pair(graph_sequence, curr_line_prop_));

	last_seq_ = graph_sequence;
}



void CStAnalyzerDlg::Plot_graph_pclr(int nSequence, Array1D_Double& dXAxisValues, Array2D_Double& pYAxisValues, Array2D_Double& pY2AxisValues, int nXYColor, int nXY2Color, int nUpdateMode)
{
	CChartWrapper* pCtrlGraph = 0;
	int seq = nSequence - 1;
	pCtrlGraph = this->GetGraphWnd(seq);

	if (nUpdateMode == 1)
	{
		Add_graph_pclr(nSequence, dXAxisValues, pYAxisValues, pY2AxisValues, nXYColor, nXY2Color);
		return;
	}
	else if (nUpdateMode == 0 && call_plot == true)
	{
		pCtrlGraph->RemoveAllPlots();
		pCtrlGraph->AddLinePointPlotEx(_T(""), 1);
		pCtrlGraph->AddLinePointPlotEx(_T(""), 1, 1);
	}

	////size_t row = dXAxisValues.size();
	size_t col = pYAxisValues.cols();

	if ((col <= 0) || (pCtrlGraph == 0))
		return;

	int nPlot = pCtrlGraph->GetLinePointPlotCount();

	int nPlotCount{ 0 };

	nPlotCount = (int)col;

	std::map<int, CStLineProperty>::iterator iter = map_line_prop_.find(nSequence);

	//int nPrev_Plot_y1 = nPlot - 3;

	if (iter != map_line_prop_.end())
	{
		pCtrlGraph->SetPlotLineWidth(nPlot - 4, iter->second.m_nXY1LineWidth);
		pCtrlGraph->SetPlotLineStyle(nPlot - 4, GetLineStyle(iter->second.m_nXY1LineStyle));
		pCtrlGraph->SetPlotLineColor(nPlot - 4, GetColor(iter->second.m_nXY1LineColor));

		pCtrlGraph->SetPlotPointStyle(nPlot - 3, GetPointStyle(iter->second.m_nXY1PointStyle));
		pCtrlGraph->SetPlotPointColor(nPlot - 3, GetColor(nXYColor));
	}

	//Susmita 02/17/06
	pCtrlGraph->SetVerticalAxis(CChartWrapper::EN_AXIS_VERTICAL_LEFT, nPlot-3);
	//Susmita 

	// 4437 - we should not plot if it is log and the value is 0
	////TestLogPlotSingle(pCtrlGraph, nPlot - 3, dXAxisVal, Vec_DataY1[0]);
	TestLogPlotSingle1D(pCtrlGraph, nPlot - 3, dXAxisValues, pYAxisValues[0]);

	//int nPrev_Plot_y2 = nPlot;
	if (iter != map_line_prop_.end())
	{
		pCtrlGraph->SetPlotLineWidth(nPlot - 1, iter->second.m_nXY2LineWidth);
		pCtrlGraph->SetPlotLineStyle(nPlot - 1, GetLineStyle(iter->second.m_nXY2LineStyle));
		pCtrlGraph->SetPlotLineColor(nPlot - 1, GetColor(iter->second.m_nXY2LineColor));

		pCtrlGraph->SetPlotPointStyle(nPlot, this->GetPointStyle(iter->second.m_nXY2PointStyle));
		pCtrlGraph->SetPlotPointColor(nPlot, this->GetColor(nXY2Color));
	}

	//Susmita 02/17/06
	pCtrlGraph->SetVerticalAxis(CChartWrapper::EN_AXIS_VERTICAL_RIGHT, nPlot);
	//Susmita 

	// 4437 - we should not plot if it is log and the value is 0
	////TestLogPlotSingle(pCtrlGraph, nPlot, dXAxisVal, Vec_DataY2[0], true);
	TestLogPlotSingle1D(pCtrlGraph, nPlot, dXAxisValues, pY2AxisValues[0], true);


	for (int i = 1; i< nPlotCount; i++)
	{
		pCtrlGraph->AddLinePointPlotEx(_T(""), 1);
		pCtrlGraph->AddLinePointPlotEx(_T(""), 1, 1);

		int nPlot = pCtrlGraph->GetLinePointPlotCount();
	
		pCtrlGraph->SetPlotLineWidth(nPlot - 4, iter->second.m_nXY1LineWidth);
		pCtrlGraph->SetPlotLineStyle(nPlot - 4, GetLineStyle(iter->second.m_nXY1LineStyle));
		pCtrlGraph->SetPlotLineColor(nPlot - 4, GetColor(iter->second.m_nXY1LineColor));

		pCtrlGraph->SetPlotPointStyle(nPlot - 3, GetPointStyle(iter->second.m_nXY1PointStyle));
		pCtrlGraph->SetPlotPointColor(nPlot - 3, GetColor(nXYColor));

		//Susmita 02/17/06
		pCtrlGraph->SetVerticalAxis(CChartWrapper::EN_AXIS_VERTICAL_LEFT, nPlot - 3);
		//Susmita 

		// 4437 - we should not plot if it is log and the value is 0
		////TestLogPlotSingle(pCtrlGraph, nPlot - 3, dXAxisVal, Vec_DataY1[i]);
		TestLogPlotSingle1D(pCtrlGraph, nPlot - 3, dXAxisValues, pYAxisValues[i]);

		pCtrlGraph->SetPlotLineWidth(nPlot - 1, iter->second.m_nXY2LineWidth);
		pCtrlGraph->SetPlotLineStyle(nPlot - 1, GetLineStyle(iter->second.m_nXY2LineStyle));
		pCtrlGraph->SetPlotLineColor(nPlot - 1, GetColor(iter->second.m_nXY2LineColor));

		pCtrlGraph->SetPlotPointStyle(nPlot, GetPointStyle(iter->second.m_nXY2PointStyle));
		pCtrlGraph->SetPlotPointColor(nPlot, GetColor(nXY2Color));

		//Susmita 02/17/06
		pCtrlGraph->SetVerticalAxis(CChartWrapper::EN_AXIS_VERTICAL_RIGHT, nPlot);
		//Susmita 

		// 4437 - we should not plot if it is log and the value is 0
		////TestLogPlotSingle(pCtrlGraph, nPlot, dXAxisVal, Vec_DataY2[i], true);
		TestLogPlotSingle1D(pCtrlGraph, nPlot, dXAxisValues, pY2AxisValues[i], true);

	}

	call_plot = true;

}

///////////////////////////////////////////////////////////////////////////////////////////////////////
// support function to append the graph

void CStAnalyzerDlg::Add_graph_pclr(int nSequence, Array1D_Double dXAxisValues, Array2D_Double pYAxisValues, Array2D_Double pY2AxisValues, int nXYColor, int nXY2Color)
{
	// Get the graph window based on the sequence number
	CPlot_Data plot_obj;
	CChartWrapper* pCtrlGraph = 0;
	int graph_sequence = nSequence;
	pCtrlGraph = this->GetGraphWnd(--nSequence);

	if (pCtrlGraph == 0)
		return;

	try
	{
		size_t rowsize = dXAxisValues.size();

		int nPlotCount{ 0 };
		nPlotCount = (int)rowsize;

		pCtrlGraph->AddLinePointPlotEx(_T(""), 1);
		pCtrlGraph->AddLinePointPlotEx(_T(""), 1, 1);

		int nPlot = pCtrlGraph->GetLinePointPlotCount();

		pCtrlGraph->SetPlotPointColor(nPlot - 2, this->GetColor(nXYColor));
		pCtrlGraph->SetVerticalAxis(CChartWrapper::EN_AXIS_VERTICAL_LEFT, nPlot - 3);

		// 4437 - we should not plot if it is log and the value is 0
		////TestLogPlotSingle(pCtrlGraph, nPlot - 3, dXAxisVal, Vec_DataY1[0]);
		TestLogPlotSingle1D(pCtrlGraph, nPlot - 3, dXAxisValues, pYAxisValues[0]);


		pCtrlGraph->SetPlotPointColor(nPlot, this->GetColor(nXY2Color));
		pCtrlGraph->SetVerticalAxis(CChartWrapper::EN_AXIS_VERTICAL_RIGHT, nPlot);

		// 4437 - we should not plot if it is log and the value is 0
		////TestLogPlotSingle(pCtrlGraph, nPlot, dXAxisVal, Vec_DataY2[0], true);
		TestLogPlotSingle1D(pCtrlGraph, nPlot, dXAxisValues, pY2AxisValues[0], true);

		for (int i = 1; i< nPlotCount; i++)
		{
			pCtrlGraph->AddLinePointPlotEx(_T(""), 1);
			pCtrlGraph->AddLinePointPlotEx(_T(""), 1, 1);

			int nPlot = pCtrlGraph->GetLinePointPlotCount();

			std::map<int, CStLineProperty>::iterator iter = map_line_prop_.find(graph_sequence);

			if (iter != map_line_prop_.end())
			{
				pCtrlGraph->SetPlotLineWidth(nPlot - 4, iter->second.m_nXY1LineWidth);
				pCtrlGraph->SetPlotLineStyle(nPlot - 4, GetLineStyle(iter->second.m_nXY1LineStyle));
				pCtrlGraph->SetPlotLineColor(nPlot - 4, GetColor(iter->second.m_nXY1LineColor));

				pCtrlGraph->SetPlotPointStyle(nPlot - 3, this->GetPointStyle(iter->second.m_nXY1PointStyle));
				pCtrlGraph->SetPlotPointColor(nPlot - 3, this->GetColor(nXYColor));
			}
			else
			{
				pCtrlGraph->SetPlotLineWidth(nPlot - 4, curr_line_prop_.m_nXY1LineWidth);
				pCtrlGraph->SetPlotLineStyle(nPlot - 4, GetLineStyle(curr_line_prop_.m_nXY1LineStyle));
				pCtrlGraph->SetPlotLineColor(nPlot - 4, GetColor(curr_line_prop_.m_nXY1LineColor));

				pCtrlGraph->SetPlotPointStyle(nPlot - 3, this->GetPointStyle(curr_line_prop_.m_nXY1PointStyle));
				pCtrlGraph->SetPlotPointColor(nPlot - 3, this->GetColor(nXYColor));
			}

			// set the style the use want to see in the graph :
			pCtrlGraph->SetVerticalAxis(CChartWrapper::EN_AXIS_VERTICAL_LEFT, nPlot - 3);

			// 4437 - we should not plot if it is log and the value is 0
			////TestLogPlotSingle(pCtrlGraph, nPlot - 3, dXAxisVal, Vec_DataY1[i]);
			TestLogPlotSingle1D(pCtrlGraph, nPlot - 3, dXAxisValues, pYAxisValues[i]);


			if (iter != map_line_prop_.end())
			{
				pCtrlGraph->SetPlotLineWidth(nPlot - 1, iter->second.m_nXY2LineWidth);
				pCtrlGraph->SetPlotLineStyle(nPlot - 1, GetLineStyle(iter->second.m_nXY2LineStyle));
				pCtrlGraph->SetPlotLineColor(nPlot - 1, GetColor(iter->second.m_nXY2LineColor));

				pCtrlGraph->SetPlotPointStyle(nPlot, this->GetPointStyle(iter->second.m_nXY2PointStyle));
				pCtrlGraph->SetPlotPointColor(nPlot, this->GetColor(nXY2Color));
			}
			else
			{
				pCtrlGraph->SetPlotLineWidth(nPlot - 1, curr_line_prop_.m_nXY2LineWidth);
				pCtrlGraph->SetPlotLineStyle(nPlot - 1, GetLineStyle(curr_line_prop_.m_nXY2LineStyle));
				pCtrlGraph->SetPlotLineColor(nPlot - 1, GetColor(curr_line_prop_.m_nXY2LineColor));

				pCtrlGraph->SetPlotPointStyle(nPlot, this->GetPointStyle(curr_line_prop_.m_nXY2PointStyle));
				pCtrlGraph->SetPlotPointColor(nPlot, this->GetColor(nXY2Color));
			}

			pCtrlGraph->SetVerticalAxis(CChartWrapper::EN_AXIS_VERTICAL_RIGHT, nPlot);

			// 4437 - we should not plot if it is log and the value is 0
			////TestLogPlotSingle(pCtrlGraph, nPlot, dXAxisVal, Vec_DataY2[i], true);
			TestLogPlotSingle1D(pCtrlGraph, nPlot, dXAxisValues, pY2AxisValues[i], true);
		}

	}
	catch (...)
	{
	}


}

/////////////////////////////////////////////////////////////////////////////

static DWORD CALLBACK MEditStreamInCallback(DWORD dwCookie, LPBYTE pbBuff, LONG cb, LONG *pcb)
{
	CString *psBuffer = (CString *)dwCookie;
	static int nTransferred = 0;
	LONG nLength = (LONG)psBuffer->GetLength();

	if (nTransferred >= nLength)
	{
		nTransferred = 0;
		*pcb = 0;
		return 0;
	}

	LONG i = 0;
	LONG j = 0;

	for (i = nTransferred, j = 0; i < nLength; i++)
	{
		if (j >= cb)
			break;
		*(pbBuff + j) = psBuffer->GetAt(i);
		j++;
	}

	*pcb = j;

	nTransferred = i;

	return 0;
}

static DWORD CALLBACK MEditStreamOutCallback(DWORD dwCookie, LPBYTE pbBuff, LONG cb, LONG *pcb)
{
	CString sThisWrite;
	sThisWrite.GetBufferSetLength(cb);

	CString *psBuffer = (CString *)dwCookie;
	

	for (int i=0;i<cb;i++) {
		sThisWrite.SetAt(i,*(pbBuff+i));
	}

	*psBuffer += sThisWrite;

	*pcb = sThisWrite.GetLength();
// 	*psBuffer += (char *)pbBuff;
 //	*pcb = strlen ((char *)pbBuff);

	return 0;
}

HBRUSH CStAnalyzerDlg::OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor)
{
	HBRUSH hbr = CDialog::OnCtlColor(pDC, pWnd, nCtlColor);

	//if (nCtlColor == CTLCOLOR_DLG) 
 //    {
 //       //CBitmap Bmp;
 //       //Bmp.LoadBitmap(IDB_ICONBITMAP);
	//	return ::CreateSolidBrush(RGB(225,225,225));
 //   }
   	return hbr;

}

void CStAnalyzerDlg::Transform(Array1D_Double &Values)
{
    size_t size = Values.size();
    for( size_t i = 0 ; i < size; ++i)
    {
        Values[i] = abs( Values[i] );
    }
}
void CStAnalyzerDlg::Transform(Array2D_Double &Values)
{
    size_t row = Values.rows();
    size_t col = Values.cols();

    for( size_t i = 0 ; i < row; ++i)
        for(size_t j = 0 ; j < col; ++j)
		{
			Values[i][j] = abs( Values[i][j] );
		}
}

void CStAnalyzerDlg::Transform(double &Value)
{
    Value = abs(Value);
}

void CStAnalyzerDlg::PositionGraph(const CRect& windowdimension)
{
	std::vector<CRect> vec_graphdimensions;

    vec_graphdimensions.reserve( text_control_count_ + graph_control_count_ );

    GetDimensions(vec_graphdimensions, windowdimension);
	
    int i=0;
   

	for(std::map<int, CEdit*>::iterator itr = m_aMapTxtWndToSequence.begin();
									   itr != m_aMapTxtWndToSequence.end();
									   ++itr)
	{
		if(itr->second->GetSafeHwnd() != NULL)
            itr->second->SetWindowPos(0,vec_graphdimensions.at(i).left,vec_graphdimensions.at(i).top,vec_graphdimensions.at(i).Width(), vec_graphdimensions.at(i).Height(),SWP_SHOWWINDOW );
		++i;
	}

	for(std::map<int, CChartWrapper*>::iterator itr = m_aMapGrpWndToSequence.begin();
																  itr != m_aMapGrpWndToSequence.end();
																  ++itr)
	{
		if(itr->second->GetSafeHwnd() != NULL)
            itr->second->SetWindowPos(0,vec_graphdimensions.at(i).left,vec_graphdimensions.at(i).top,vec_graphdimensions.at(i).Width(), vec_graphdimensions.at(i).Height(),SWP_SHOWWINDOW );
		++i;
	}
}

void CStAnalyzerDlg::GetDimensions(std::vector<CRect>& vecdimensions, const CRect& windowdimension)
{
	CRect rectdimension;

    int graph_width, graph_height;

    int control_per_row = 0;

    int control_count = text_control_count_ + graph_control_count_;

    GetControlDimension(windowdimension, graph_width, graph_height);
 
	for(int n = 0; n < control_count; n++)
	{
        switch(n)
        {
        case 0:
            rectdimension.left = windowdimension.left;
			rectdimension.top  = windowdimension.top;
			rectdimension.right = graph_width + pad_;
			rectdimension.bottom = graph_height + pad_;
			vecdimensions.push_back(rectdimension);
            break;

        case 1:
            rectdimension.left = (vecdimensions.at(n-1)).right;
            rectdimension.top  =  (vecdimensions.at(n-1)).top;
            rectdimension.right = rectdimension.left + graph_width;
            rectdimension.bottom = graph_height + pad_;
            vecdimensions.push_back(rectdimension);
            break;
        case 2:
			{
                switch(control_count)
                {
                    case 3:
                    case 4:
                        control_per_row = 2;
                        rectdimension.left = (vecdimensions.at(0)).left;
                        rectdimension.top  =  (vecdimensions.at(0)).bottom;
                        rectdimension.right = rectdimension.left + graph_width;
                        rectdimension.bottom = rectdimension.top + graph_height;
                        vecdimensions.push_back(rectdimension);
                    break;
                    case 5:
                    case 6:
                    case 7:
                    case 8:
                    case 9:
                    case 10:
                    case 11:
                    case 12:
                    case 13:
                    case 14:
                    case 15:
                    case 16:
                        control_per_row = 3;
                        rectdimension.left = (vecdimensions.at(n - 1)).right;
                        rectdimension.top  =  (vecdimensions.at(n - 1)).top;
                        rectdimension.right = rectdimension.left + graph_width;
                        rectdimension.bottom = rectdimension.top + graph_height;
                        vecdimensions.push_back(rectdimension);
                    break;
                }
            }
            break;
        case 3:
            {
                switch(control_count)
                {
                    
                    case 4:
                    
                        control_per_row = 2;
                        rectdimension.left = (vecdimensions.at(1)).left;
                        rectdimension.top  =  (vecdimensions.at(1)).bottom;
                        rectdimension.right = rectdimension.left + graph_width;
                        rectdimension.bottom = rectdimension.top + graph_height;
                        vecdimensions.push_back(rectdimension);
                    break;
                    case 5:
                    case 6:
                    case 7:
                    case 8:
                    case 9:
                        rectdimension.left = (vecdimensions.at(0)).left;
                        rectdimension.top  =  (vecdimensions.at(0)).bottom;
                        rectdimension.right = rectdimension.left + graph_width;
                        rectdimension.bottom = rectdimension.top + graph_height;
                        vecdimensions.push_back(rectdimension);
                    break;
                    case 10:
                    case 11:
                    case 12:
                    case 13:
                    case 14:
                    case 15:
                    case 16:
                        control_per_row = 3;
                        rectdimension.left = (vecdimensions.at(n - 1)).right;
                        rectdimension.top  =  (vecdimensions.at(n - 1)).top;
                        rectdimension.right = rectdimension.left + graph_width;
                        rectdimension.bottom = rectdimension.top + graph_height;
                        vecdimensions.push_back(rectdimension);
                    break;
                }
            }
            break;
        case 4:
            {
                switch(control_count)
                {
                    
                    case 5:
                    case 6:
                    case 7:
                    case 8:
                    case 9:
                        control_per_row = 2;
                        rectdimension.left = (vecdimensions.at(1)).left;
                        rectdimension.top  =  (vecdimensions.at(1)).bottom;
                        rectdimension.right = rectdimension.left + graph_width;
                        rectdimension.bottom = rectdimension.top + graph_height;
                        vecdimensions.push_back(rectdimension);
                    break;
                    case 10:
                    case 11:
                    case 12:
                    case 13:
                    case 14:
                    case 15:
                    case 16:
                        rectdimension.left = (vecdimensions.at(0)).left;
                        rectdimension.top  =  (vecdimensions.at(0)).bottom;
                        rectdimension.right = rectdimension.left + graph_width;
                        rectdimension.bottom = rectdimension.top + graph_height;
                        vecdimensions.push_back(rectdimension);
                    break;
                }
            }
            break;
        case 5:
            {
                switch(control_count)
                {
                    case 6:
                    case 7:
                    case 8:
                    case 9:    
                        rectdimension.left = (vecdimensions.at(2)).left;
                        rectdimension.top  =  (vecdimensions.at(2)).bottom;
                        rectdimension.right = rectdimension.left + graph_width;
                        rectdimension.bottom = rectdimension.top + graph_height;
                        vecdimensions.push_back(rectdimension);
                    break;
                    
                    case 10:
                    case 11:
                    case 12:
                    case 13:
                    case 14:
                    case 15:
                    case 16:
                        rectdimension.left = (vecdimensions.at(1)).left;
                        rectdimension.top  =  (vecdimensions.at(1)).bottom;
                        rectdimension.right = rectdimension.left + graph_width;
                        rectdimension.bottom = rectdimension.top + graph_height;
                        vecdimensions.push_back(rectdimension);
                        break;
                }
            }
            break;
        
        case 6:
            {
                switch(control_count)
                {
                    
                    case 7:
                    case 8:
                    case 9:    
                        rectdimension.left = (vecdimensions.at(3)).left;
                        rectdimension.top  =  (vecdimensions.at(3)).bottom;
                        rectdimension.right = rectdimension.left + graph_width;
                        rectdimension.bottom = rectdimension.top + graph_height;
                        vecdimensions.push_back(rectdimension);
                    break;
                    
                    case 10:
                    case 11:
                    case 12:
                    case 13:
                    case 14:
                    case 15:
                    case 16:
                        rectdimension.left = (vecdimensions.at(2)).left;
                        rectdimension.top  =  (vecdimensions.at(2)).bottom;
                        rectdimension.right = rectdimension.left + graph_width;
                        rectdimension.bottom = rectdimension.top + graph_height;
                        vecdimensions.push_back(rectdimension);
                        break;
                }
            }
            break;
        case 7:
            {
                switch(control_count)
                {
                    
                    case 8:
                    case 9:    
                        rectdimension.left = (vecdimensions.at(4)).left;
                        rectdimension.top  =  (vecdimensions.at(4)).bottom;
                        rectdimension.right = rectdimension.left + graph_width;
                        rectdimension.bottom = rectdimension.top + graph_height;
                        vecdimensions.push_back(rectdimension);
                    break;
                    
                    case 10:
                    case 11:
                    case 12:
                    case 13:
                    case 14:
                    case 15:
                    case 16:
                        rectdimension.left = (vecdimensions.at(3)).left;
                        rectdimension.top  =  (vecdimensions.at(3)).bottom;
                        rectdimension.right = rectdimension.left + graph_width;
                        rectdimension.bottom = rectdimension.top + graph_height;
                        vecdimensions.push_back(rectdimension);
                        break;
                }
            }
            break;
        case 8:
            {
                switch(control_count)
                {
                    
                    case 9:    
                        rectdimension.left = (vecdimensions.at(5)).left;
                        rectdimension.top  =  (vecdimensions.at(5)).bottom;
                        rectdimension.right = rectdimension.left + graph_width;
                        rectdimension.bottom = rectdimension.top + graph_height;
                        vecdimensions.push_back(rectdimension);
                    break;
                    
                    case 10:
                    case 11:
                    case 12:
                    case 13:
                    case 14:
                    case 15:
                    case 16:
                        rectdimension.left = (vecdimensions.at(4)).left;
                        rectdimension.top  =  (vecdimensions.at(4)).bottom;
                        rectdimension.right = rectdimension.left + graph_width;
                        rectdimension.bottom = rectdimension.top + graph_height;
                        vecdimensions.push_back(rectdimension);
                        break;
                }
            }
            break;
        case 9:
            {
                switch(control_count)
                {
                    
                    case 10:
                    case 11:
                    case 12:
                    case 13:
                    case 14:
                    case 15:
                    case 16:
                        rectdimension.left = (vecdimensions.at(5)).left;
                        rectdimension.top  =  (vecdimensions.at(5)).bottom;
                        rectdimension.right = rectdimension.left + graph_width;
                        rectdimension.bottom = rectdimension.top + graph_height;
                        vecdimensions.push_back(rectdimension);
                        break;
                }
            }
            break;
        case 10:
            {
                switch(control_count)
                {
                    case 11:
                    case 12:
                    case 13:
                    case 14:
                    case 15:
                    case 16:
                        rectdimension.left = (vecdimensions.at(6)).left;
                        rectdimension.top  =  (vecdimensions.at(6)).bottom;
                        rectdimension.right = rectdimension.left + graph_width;
                        rectdimension.bottom = rectdimension.top + graph_height;
                        vecdimensions.push_back(rectdimension);
                        break;
                }
            }
            break;
        case 11:
            {
                switch(control_count)
                {
                    case 12:
                    case 13:
                    case 14:
                    case 15:
                    case 16:
                        rectdimension.left = (vecdimensions.at(7)).left;
                        rectdimension.top  =  (vecdimensions.at(7)).bottom;
                        rectdimension.right = rectdimension.left + graph_width;
                        rectdimension.bottom = rectdimension.top + graph_height;
                        vecdimensions.push_back(rectdimension);
                        break;
                }
            }
            break;
            
        case 12:
            {
                switch(control_count)
                {
                    
                    case 13:
                    case 14:
                    case 15:
                    case 16:
                        rectdimension.left = (vecdimensions.at(8)).left;
                        rectdimension.top  =  (vecdimensions.at(8)).bottom;
                        rectdimension.right = rectdimension.left + graph_width;
                        rectdimension.bottom = rectdimension.top + graph_height;
                        vecdimensions.push_back(rectdimension);
                        break;
                }
            }
            break;
        case 13:
            {
                switch(control_count)
                {
                    
                    case 14:
                    case 15:
                    case 16:
                        rectdimension.left = (vecdimensions.at(9)).left;
                        rectdimension.top  =  (vecdimensions.at(9)).bottom;
                        rectdimension.right = rectdimension.left + graph_width;
                        rectdimension.bottom = rectdimension.top + graph_height;
                        vecdimensions.push_back(rectdimension);
                        break;
                }
            }
            break;
        case 14:
            {
                switch(control_count)
                {
                   
                    case 15:
                    case 16:
                        rectdimension.left = (vecdimensions.at(10)).left;
                        rectdimension.top  =  (vecdimensions.at(10)).bottom;
                        rectdimension.right = rectdimension.left + graph_width;
                        rectdimension.bottom = rectdimension.top + graph_height;
                        vecdimensions.push_back(rectdimension);
                        break;
                }
            }
            break;
        case 15:
            {
                switch(control_count)
                {
                    case 16:
                        rectdimension.left = (vecdimensions.at(11)).left;
                        rectdimension.top  =  (vecdimensions.at(11)).bottom;
                        rectdimension.right = rectdimension.left + graph_width;
                        rectdimension.bottom = rectdimension.top + graph_height;
                        vecdimensions.push_back(rectdimension);
                        break;
                }
            }
            break;
                    
        }
    }
}

void CStAnalyzerDlg::GetControlWidth(const CRect &windowdimension, int &graph_width,const int total_wnd_count)
{
    switch(total_wnd_count)
    {
        case 1:
            graph_width = windowdimension.Width();
            break;
        case 2:
            graph_width = windowdimension.Width() / 2;
            break;
        case 3:
        case 4:
            graph_width = windowdimension.Width() / 2;
            break;
        case 5:
        case 6:
            graph_width = windowdimension.Width() / 3;
            break;
        case 7:
        case 8:
        case 9:
            graph_width = windowdimension.Width() / 3;
            break;
        case 10:
        case 11:
        case 12:
            graph_width = windowdimension.Width() / 4;
            break;
        case 13:
        case 14:
        case 15:
        case 16:
            graph_width = windowdimension.Width() / 4;
            break;
        default:;
    }
}

void CStAnalyzerDlg::GetControlHeight(const CRect &windowdimension, int &height,const int total_wnd_count)
{
    switch(total_wnd_count)
    {
        case 1:
            height = windowdimension.Height();
            break;
        case 2:
            height = windowdimension.Height();
            break;
        case 3:
        case 4:
            height = windowdimension.Height() / 2;
            break;
        case 5:
        case 6:
            height = windowdimension.Height() / 2;
            break;
        case 7:
        case 8:
        case 9:
            height = windowdimension.Height() / 3;
            break;
        case 10:
        case 11:
        case 12:
            height = windowdimension.Height() / 3;
            break;
        case 13:
        case 14:
        case 15:
        case 16:
            height = windowdimension.Height() / 4;
            break;
        default:;
    }
}

void CStAnalyzerDlg::GetControlDimension(const CRect &windowdimension, int &graph_width, int &graph_height)
{
    int control_count = text_control_count_ + graph_control_count_;

    GetControlWidth(windowdimension,graph_width,control_count);
    GetControlHeight(windowdimension,graph_height,control_count);

	//LOG_DEBUG << "GetControlDimension" << ENDLOG;
}

void CStAnalyzerDlg::OnSize(UINT nType, int cx, int cy)
{
    CDialog::OnSize(nType, cx, cy);

}

BEGIN_EVENTSINK_MAP(CStAnalyzerDlg, CDialog)
END_EVENTSINK_MAP()

void CStAnalyzerDlg::OnGetNextAxisLabelTchart1(long Axis, long LabelIndex, double* LabelValue, BOOL* MoreLabels)
{
	// TODO: Add your message handler code here
	std::map<int, CTChartLabels>::iterator itr = map_label_.find(1);
	if (itr != map_label_.end())
	{
		if (Axis == 0)
		{
			if (itr->second.Y1Labels.size() != 0)
			{
				if (val1_)
				{
					itr_deq1 = itr->second.Y1Labels.begin();
					val1_ = false;
				}
				if (itr_deq1 != itr->second.Y1Labels.end())
				{
					*LabelValue = itr_deq1->x1_;
					itr_deq1++;
				}
				if (LabelIndex <= 5)
					*MoreLabels = TRUE;
				else
				{
					*MoreLabels = FALSE;
					val1_ = true;
					val2_ = true;
				}
			}

		}
		if (Axis == 2)
		{
			if (itr->second.Y2Labels.size() != 0)
			{
				if (val2_)
				{
					itr_deq2 = itr->second.Y2Labels.begin();
					val2_ = false;
				}
				if (itr_deq2 != itr->second.Y2Labels.end())
				{
					*LabelValue = itr_deq2->x1_;
					itr_deq2++;
				}
				if (LabelIndex <= 5)
					*MoreLabels = TRUE;
				else
				{
					*MoreLabels = FALSE;
					val1_ = true;
					val2_ = true;
				}
			}

		}
		if (Axis == 3)
		{
			if (itr->second.XLabels.size() != 0)
			{
				if (val1_)
				{
					itr_deq3 = itr->second.XLabels.begin();
					val1_ = false;
				}
				if (itr_deq3 != itr->second.XLabels.end())
				{
					*LabelValue = itr_deq3->x1_;
					itr_deq3++;
				}
				if (LabelIndex <= 5)
					*MoreLabels = TRUE;
				else
				{
					*MoreLabels = FALSE;
					val1_ = true;
					val2_ = true;
				}
			}

		}
	}


}

void CStAnalyzerDlg::OnGetNextAxisLabelTchart2(long Axis, long LabelIndex, double* LabelValue, BOOL* MoreLabels)
{
	// TODO: Add your message handler code here

	std::map<int, CTChartLabels>::iterator itr = map_label_.find(2);
	if (itr != map_label_.end())
	{
		if (Axis == 0)
		{

			if (itr->second.Y1Labels.size() != 0)
			{
				if (val1_)
				{
					itr_deq1 = itr->second.Y1Labels.begin();
					val1_ = false;
				}
				if (itr_deq1 != itr->second.Y1Labels.end())
				{
					*LabelValue = itr_deq1->x1_;
					itr_deq1++;
				}
				if (LabelIndex <= 5)
					*MoreLabels = TRUE;
				else
				{
					*MoreLabels = FALSE;
					val1_ = true;
					val2_ = true;
				}
			}

		}
		if (Axis == 2)
		{
			if (itr->second.Y2Labels.size() != 0)
			{
				if (val2_)
				{
					itr_deq2 = itr->second.Y2Labels.begin();
					val2_ = false;
				}
				if (itr_deq2 != itr->second.Y2Labels.end())
				{
					*LabelValue = itr_deq2->x1_;
					itr_deq2++;
				}
				if (LabelIndex <= 5)
					*MoreLabels = TRUE;
				else
				{
					*MoreLabels = FALSE;
					val1_ = true;
					val2_ = true;
				}
			}

		}
		if (Axis == 3)
		{
			if (itr->second.XLabels.size() != 0)
			{
				if (val1_)
				{
					itr_deq3 = itr->second.XLabels.begin();
					val1_ = false;
				}
				if (itr_deq3 != itr->second.XLabels.end())
				{
					*LabelValue = itr_deq3->x1_;
					itr_deq3++;
				}
				if (LabelIndex <= 5)
					*MoreLabels = TRUE;
				else
				{
					*MoreLabels = FALSE;
					val1_ = true;
					val2_ = true;
				}
			}

		}
	}

}

void CStAnalyzerDlg::OnGetAxisLabelTchart1(long Axis, long SeriesIndex, long ValueIndex, BSTR* LabelText)
{
	std::map<int, CGraphAxisInfo>::iterator itr = map_axisinfo_.find(1);
	if (itr != map_axisinfo_.end())
	{
		if (Axis == 0)
		{
			CString csVal2(*LabelText);
			CString csVal3("0");

			int index = csVal2.Find("e");
			if (index == -1)
				return;

			CString str = csVal2.Mid(index + 1);

			int curr_val = atoi(str);

			if (abs(curr_val) < 5)
			{
				str = csVal2.Mid(0, index);
				double i = atof(str);
				if (curr_val < 0)
				{
					i = i / (pow(10.0, abs(curr_val)));
					if (abs(curr_val) == 1)
						str.Format(_T("%0.2f"), i);
					if (abs(curr_val) == 2)
						str.Format(_T("%0.3f"), i);
					if (abs(curr_val) == 3)
						str.Format(_T("%0.4f"), i);
					if (abs(curr_val) == 4)
						str.Format(_T("%0.5f"), i);
				}
				else
				{
					int j = int(i*(pow(10.0, curr_val)));
					str.Format(_T("%d"), j);
				}
				BSTR bVal2 = str.AllocSysString();
				*LabelText = bVal2;
				SysFreeString(bVal2);
				prevVal_ = curr_val;
				formatcheck_ = true;
				itr->second.lastLabelY1_ = atof(csVal2);
				return;
			}

			//int diff = abs(curr_val - prevVal_);
			double currLabel = atof(csVal2);

			if (currLabel > 0 && itr->second.lastLabelY1_ > 0)
			{
				int q1 = abs(curr_val) / 10;
				int d1 = 1;
				while (q1 >= 10)
				{
					q1 = q1 / 10;
					d1++;
				}

				int q2 = abs(prevVal_) / 10;
				int d2 = 1;
				while (q2 >= 10)
				{
					q2 = q2 / 10;
					d2++;
				}

				int diff = d1 - d2;
				if (diff > 0)
				{
					BSTR bVal2 = csVal3.AllocSysString();
					*LabelText = bVal2;
					SysFreeString(bVal2);

					prevVal_ = curr_val;
					itr->second.lastLabelY1_ = 0;
					return;
				}

				if (d1 == 1)
				{
					int diff = abs(curr_val) - abs(prevVal_);
					if (diff > 5)
					{
						BSTR bVal2 = csVal3.AllocSysString();
						*LabelText = bVal2;
						SysFreeString(bVal2);

						prevVal_ = curr_val;
						itr->second.lastLabelY1_ = 0;
						return;
					}
				}
			}

			//if (diff > 5)
			if ((itr->second.lastLabelY1_ > 0 && currLabel < 0) ||
				(itr->second.lastLabelY1_ < 0 && currLabel > 0))
			{
				BSTR bVal2 = csVal3.AllocSysString();
				*LabelText = bVal2;
				SysFreeString(bVal2);
				//itr->second.countY1_ = 1;
				itr->second.lastLabelY1_ = 0;
			}
			else
				itr->second.lastLabelY1_ = atof(csVal2);
		
			prevVal_ = curr_val;
		}

		if (Axis == 2)
		{
			CString csVal2(*LabelText);
			CString csVal3("0");

			int index = csVal2.Find("e");
			if (index == -1)
				return;

			CString str = csVal2.Mid(index + 1);

			int curr_val = atoi(str);
			if (abs(curr_val) < 5)
			{
				str = csVal2.Mid(0, index);
				double i = atof(str);
				if (curr_val < 0)
				{
					i = i / (pow(10.0, abs(curr_val)));
					if (abs(curr_val) == 1)
						str.Format(_T("%0.2f"), i);
					if (abs(curr_val) == 2)
						str.Format(_T("%0.3f"), i);
					if (abs(curr_val) == 3)
						str.Format(_T("%0.4f"), i);
					if (abs(curr_val) == 4)
						str.Format(_T("%0.5f"), i);
				}
				else
				{
					int j = int(i*(pow(10.0, curr_val)));
					str.Format(_T("%d"), j);
				}
				BSTR bVal2 = str.AllocSysString();
				*LabelText = bVal2;
				SysFreeString(bVal2);
				prevVal_ = curr_val;
				formatcheck_ = true;
				itr->second.lastLabelY2_ = atof(csVal2);
				return;
			}

			//int diff = abs(curr_val - prevVal_);
			double currLabel = atof(csVal2);
			if (currLabel > 0 && itr->second.lastLabelY2_ > 0)
			{
				int q1 = abs(curr_val) / 10;
				int d1 = 1;
				while (q1 >= 10)
				{
					q1 = q1 / 10;
					d1++;
				}

				int q2 = abs(prevVal_) / 10;
				int d2 = 1;
				while (q2 >= 10)
				{
					q2 = q2 / 10;
					d2++;
				}

				int diff = d1 - d2;
				if (diff > 0)
				{
					BSTR bVal2 = csVal3.AllocSysString();
					*LabelText = bVal2;
					SysFreeString(bVal2);

					prevVal_ = curr_val;
					itr->second.lastLabelY2_ = 0;
					return;
				}	

				if (d1 == 1)
				{
					int diff = abs(curr_val) - abs(prevVal_);
					if (diff > 5)
					{
						BSTR bVal2 = csVal3.AllocSysString();
						*LabelText = bVal2;
						SysFreeString(bVal2);

						prevVal_ = curr_val;
						itr->second.lastLabelY2_ = 0;
						return;
					}
				}
			}

			//if (diff > 5)
			if ((itr->second.lastLabelY2_ > 0 && currLabel < 0) ||
				(itr->second.lastLabelY2_ < 0 && currLabel > 0))
			{
				BSTR bVal2 = csVal3.AllocSysString();
				*LabelText = bVal2;
				SysFreeString(bVal2);
				//itr->second.countY2_ = 1;
				itr->second.lastLabelY2_ = 0;
			}
			else
				itr->second.lastLabelY2_ = atof(csVal2);
		
			prevVal_ = curr_val;
		}

		if (Axis == 3)
		{
			CString csVal2(*LabelText);
			CString csVal3("0");

			int index = csVal2.Find("e");
			if (index == -1)
				return;

			CString str = csVal2.Mid(index + 1);

			int curr_val = atoi(str);
			if (abs(curr_val) < 5)
			{
				str = csVal2.Mid(0, index);
				double i = atof(str);
				if (curr_val < 0)
				{
					i = i / (pow(10.0, abs(curr_val)));
					if (abs(curr_val) == 1)
						str.Format(_T("%0.2f"), i);
					if (abs(curr_val) == 2)
						str.Format(_T("%0.3f"), i);
					if (abs(curr_val) == 3)
						str.Format(_T("%0.4f"), i);
					if (abs(curr_val) == 4)
						str.Format(_T("%0.5f"), i);
				}
				else
				{
					int j = int(i*(pow(10.0, curr_val)));
					str.Format(_T("%d"), j);
				}
				BSTR bVal2 = str.AllocSysString();
				*LabelText = bVal2;
				SysFreeString(bVal2);
				itr->second.lastLabelX_ = atof(csVal2);
				return;
			}

			double currLabel = atof(csVal2);

			if (currLabel > 0 && itr->second.lastLabelX_ > 0)
			{
				int q1 = abs(curr_val) / 10;
				int d1 = 1;
				while (q1 >= 10)
				{
					q1 = q1 / 10;
					d1++;
				}

				int q2 = abs(prevVal_) / 10;
				int d2 = 1;
				while (q2 >= 10)
				{
					q2 = q2 / 10;
					d2++;
				}

				int diff = d1 - d2;
				if (diff > 0)
				{
					BSTR bVal2 = csVal3.AllocSysString();
					*LabelText = bVal2;
					SysFreeString(bVal2);

					prevVal_ = curr_val;
					itr->second.lastLabelX_ = 0;
					return;
				}
			}
			
			//if (diff > 5)
			if ((itr->second.lastLabelX_ > 0 && currLabel < 0) ||
				(itr->second.lastLabelX_ < 0 && currLabel > 0))
			{
				BSTR bVal2 = csVal3.AllocSysString();
				*LabelText = bVal2;
				SysFreeString(bVal2);
				//itr->second.countX_ = 1;
				itr->second.lastLabelX_ = 0;
			}
			else
				itr->second.lastLabelX_ = atof(csVal2);

			prevVal_ = curr_val;
		}
	}
}

void CStAnalyzerDlg::OnGetAxisLabelTchart2(long Axis, long SeriesIndex, long ValueIndex, BSTR* LabelText)
{
	std::map<int, CGraphAxisInfo>::iterator itr = map_axisinfo_.find(2);
	if (itr != map_axisinfo_.end())
	{
		if (Axis == 0)
		{
			CString csVal2(*LabelText);
			CString csVal3("0");

			int index = csVal2.Find("e");
			if (index == -1)
				return;

			CString str = csVal2.Mid(index + 1);

			int curr_val = atoi(str);
			if (abs(curr_val) < 5)
			{
				str = csVal2.Mid(0, index);
				double i = atof(str);
				if (curr_val < 0)
				{
					i = i / (pow(10.0, abs(curr_val)));
					if (abs(curr_val) == 1)
						str.Format(_T("%0.2f"), i);
					if (abs(curr_val) == 2)
						str.Format(_T("%0.3f"), i);
					if (abs(curr_val) == 3)
						str.Format(_T("%0.4f"), i);
					if (abs(curr_val) == 4)
						str.Format(_T("%0.5f"), i);
				}
				else
				{
					int j = int(i*(pow(10.0, curr_val)));
					str.Format(_T("%d"), j);
				}
				BSTR bVal2 = str.AllocSysString();
				*LabelText = bVal2;
				SysFreeString(bVal2);
				prevVal_ = curr_val;
				formatcheck_ = true;
				itr->second.lastLabelY1_ = atof(csVal2);
				return;
			}

			double currLabel = atof(csVal2);
			if (currLabel > 0 && itr->second.lastLabelY1_ > 0)
			{
				int q1 = abs(curr_val) / 10;
				int d1 = 1;
				while (q1 >= 10)
				{
					q1 = q1 / 10;
					d1++;
				}

				int q2 = abs(prevVal_) / 10;
				int d2 = 1;
				while (q2 >= 10)
				{
					q2 = q2 / 10;
					d2++;
				}

				int diff = d1 - d2;
				if (diff > 0)
				{
					BSTR bVal2 = csVal3.AllocSysString();
					*LabelText = bVal2;
					SysFreeString(bVal2);

					prevVal_ = curr_val;
					itr->second.lastLabelY1_ = 0;
					return;
				}

				if (d1 == 1)
				{
					int diff = abs(curr_val) - abs(prevVal_);
					if (diff > 5)
					{
						BSTR bVal2 = csVal3.AllocSysString();
						*LabelText = bVal2;
						SysFreeString(bVal2);

						prevVal_ = curr_val;
						itr->second.lastLabelY1_ = 0;
						return;
					}
				}
			}

			//if (diff > 5)
			if ((itr->second.lastLabelY1_ > 0 && currLabel < 0) ||
				(itr->second.lastLabelY1_ < 0 && currLabel > 0))
			{
				BSTR bVal2 = csVal3.AllocSysString();
				*LabelText = bVal2;
				SysFreeString(bVal2);
				//itr->second.countY1_ = 1;
				itr->second.lastLabelY1_ = 0;
			}
			else
				itr->second.lastLabelY1_ = atof(csVal2);

			prevVal_ = curr_val;
		}

		if (Axis == 2)
		{
			CString csVal2(*LabelText);
			CString csVal3("0");

			int index = csVal2.Find("e");
			if (index == -1)
				return;

			CString str = csVal2.Mid(index + 1);

			int curr_val = atoi(str);
			if (abs(curr_val) < 5)
			{
				str = csVal2.Mid(0, index);
				double i = atof(str);
				if (curr_val < 0)
				{
					i = i / (pow(10.0, abs(curr_val)));
					if (abs(curr_val) == 1)
						str.Format(_T("%0.2f"), i);
					if (abs(curr_val) == 2)
						str.Format(_T("%0.3f"), i);
					if (abs(curr_val) == 3)
						str.Format(_T("%0.4f"), i);
					if (abs(curr_val) == 4)
						str.Format(_T("%0.5f"), i);
				}
				else
				{
					int j = int(i*(pow(10.0, curr_val)));
					str.Format(_T("%d"), j);
				}

				BSTR bVal2 = str.AllocSysString();
				*LabelText = bVal2;
				SysFreeString(bVal2);
				prevVal_ = curr_val;
				formatcheck_ = true;
				itr->second.lastLabelY2_ = atof(csVal2);
				return;
			}

			double currLabel = atof(csVal2);
			if (currLabel > 0 && itr->second.lastLabelY2_ > 0)
			{
				int q1 = abs(curr_val) / 10;
				int d1 = 1;
				while (q1 >= 10)
				{
					q1 = q1 / 10;
					d1++;
				}

				int q2 = abs(prevVal_) / 10;
				int d2 = 1;
				while (q2 >= 10)
				{
					q2 = q2 / 10;
					d2++;
				}

				int diff = d1 - d2;
				if (diff > 0)
				{
					BSTR bVal2 = csVal3.AllocSysString();
					*LabelText = bVal2;
					SysFreeString(bVal2);

					prevVal_ = curr_val;
					itr->second.lastLabelY2_ = 0;
					return;
				}

				if (d1 == 1)
				{
					int diff = abs(curr_val) - abs(prevVal_);
					if (diff > 5)
					{
						BSTR bVal2 = csVal3.AllocSysString();
						*LabelText = bVal2;
						SysFreeString(bVal2);

						prevVal_ = curr_val;
						itr->second.lastLabelY2_ = 0;
						return;
					}
				}
			}

			//if (diff > 5)
			if ((itr->second.lastLabelY2_ > 0 && currLabel < 0) ||
				(itr->second.lastLabelY2_ < 0 && currLabel > 0))
			{
				BSTR bVal2 = csVal3.AllocSysString();
				*LabelText = bVal2;
				SysFreeString(bVal2);
				//itr->second.countY2_ = 1;
				itr->second.lastLabelY2_ = 0;
			}
			else
				itr->second.lastLabelY2_ = atof(csVal2);

			prevVal_ = curr_val;
		}

		if (Axis == 3)
		{
			CString csVal2(*LabelText);
			CString csVal3("0");

			int index = csVal2.Find("e");
			if (index == -1)
				return;

			CString str = csVal2.Mid(index + 1);

			int curr_val = atoi(str);
			if (abs(curr_val) < 5)
			{
				str = csVal2.Mid(0, index);
				double i = atof(str);
				if (curr_val < 0)
				{
					i = i / (pow(10.0, abs(curr_val)));
					if (abs(curr_val) == 1)
						str.Format(_T("%0.2f"), i);
					if (abs(curr_val) == 2)
						str.Format(_T("%0.3f"), i);
					if (abs(curr_val) == 3)
						str.Format(_T("%0.4f"), i);
					if (abs(curr_val) == 4)
						str.Format(_T("%0.5f"), i);
				}
				else
				{
					int j = int(i*(pow(10.0, curr_val)));
					str.Format(_T("%d"), j);
				}
				BSTR bVal2 = str.AllocSysString();
				*LabelText = bVal2;
				SysFreeString(bVal2);
				itr->second.lastLabelX_ = atof(csVal2);
				return;
			}

			double currLabel = atof(csVal2);

			if (currLabel > 0 && itr->second.lastLabelX_ > 0)
			{
				int q1 = abs(curr_val) / 10;
				int d1 = 1;
				while (q1 >= 10)
				{
					q1 = q1 / 10;
					d1++;
				}

				int q2 = abs(prevVal_) / 10;
				int d2 = 1;
				while (q2 >= 10)
				{
					q2 = q2 / 10;
					d2++;
				}

				int diff = d1 - d2;
				if (diff > 0)
				{
					BSTR bVal2 = csVal3.AllocSysString();
					*LabelText = bVal2;
					SysFreeString(bVal2);

					prevVal_ = curr_val;
					itr->second.lastLabelX_ = 0;
					return;
				}
			}

			//if (diff > 5)
			if ((itr->second.lastLabelX_ > 0 && currLabel < 0) ||
				(itr->second.lastLabelX_ < 0 && currLabel > 0))
			{
				BSTR bVal2 = csVal3.AllocSysString();
				*LabelText = bVal2;
				SysFreeString(bVal2);
				//itr->second.countX_ = 1;
				itr->second.lastLabelX_ = 0;
			}
			else
				itr->second.lastLabelX_ = atof(csVal2);

			prevVal_ = curr_val;
		}
	}
}

void CStAnalyzerDlg::OnExitSizeMove()
{
	// TODO: Add your message handler code here and/or call default

	if (GetSafeHwnd() != NULL)
	{
		CRect clientrect;
		GetClientRect(&clientrect);
		clientrect.NormalizeRect();
		clientrect.top = pad_;
		clientrect.left = pad_;
		clientrect.bottom = clientrect.bottom - pad_;
		clientrect.right = clientrect.right - pad_;
		PositionGraph(clientrect);
	}
	CDialog::OnExitSizeMove();
}
