#pragma once

////#include "Sagi.Core Data/realtimedata.h"
////#include "datatypes.h"
////#include "ResizeCtrl.h"
#include "Chartwrapper.h"
#include "tchart.h"
#include <vector>
#include <afxtempl.h>
#include <deque>
#include <map>

#define ONED_LEFT 5
#define ONED_TOP 10
#define RESOURCEID_CONSTANT 2003


static const UINT UWM_RESET_DLG_CONTENT = WM_USER + 1000;
static const UINT UWM_ENABLE_MENU_ITEM = UWM_RESET_DLG_CONTENT + 1;
static const UINT UWM_PLOT_GIS_TEXT = UWM_ENABLE_MENU_ITEM + 1;
static const UINT UWM_CALL_GRAPH_FUNCTION = UWM_PLOT_GIS_TEXT + 1;
static const UINT UWM_REMOVE_ANALYZER_WND = UWM_CALL_GRAPH_FUNCTION + 1;
static const UINT UWM_CREATE_SUB_WINDOW = UWM_REMOVE_ANALYZER_WND + 1;
static const UINT UWM_SET_CLOSE_MODE = UWM_CREATE_SUB_WINDOW + 1;
static const UINT UWM_PROCESS_ANALYZER_WND_FUNC = UWM_SET_CLOSE_MODE + 1;
static const UINT WM_SET_DIALOG_MENU = UWM_PROCESS_ANALYZER_WND_FUNC + 1;
static const UINT UWM_REMOVE_ANALYZER_THREAD = WM_SET_DIALOG_MENU + 1;
static const UINT UWM_CREATE_FILE_READER_WRITER_THREAD = UWM_REMOVE_ANALYZER_THREAD + 1;


namespace nsSTAr
{
	namespace nsChartDataType
	{
		typedef std::vector<double> CReal64Vector;
		enum enChartLineStyle;
		enum enChartPointStyle;
	}
}

struct CY1TChartLabels
{
	double x1_;


	CY1TChartLabels() : x1_(0){}
};
struct CY2TChartLabels
{
	double x1_;


	CY2TChartLabels() : x1_(0){}
};
struct CXTChartLabels
{
	double x1_;


	CXTChartLabels() : x1_(0){}
};
struct CTChartLabels
{
	std::deque<CY1TChartLabels>				 Y1Labels;
	std::deque<CY2TChartLabels>				 Y2Labels;
	std::deque<CXTChartLabels>				 XLabels;
};

struct CGraphAxisInfo
{
	int countX_;
	int countY1_;
	int countY2_;
	double lastLabelX_;
	double lastLabelY1_;
	double lastLabelY2_;
};

	// CStAnalyzerDlg dialog

	class CStAnalyzerDlg : public CDialog
	{
		DECLARE_DYNAMIC(CStAnalyzerDlg)
		
	public:
		
		// Dialog data
		enum { IDD = IDD_STREALTIMEANALYZER_WND };
		// data 
		CString m_strTest;
		CString m_strTester;
		int m_nGraphResourceID;
		int m_nTextResourceID;

		BSTR bstrLic;

		std::map<int, CChartWrapper *> m_aMapGrpWndToSequence;

		std::map<int, CEdit*> m_aMapTxtWndToSequence;
		std::vector<HFONT> vec_font_;


		CMap<int, int&, CStringArray*, CStringArray* &> m_aGraphWndToParam;

		CStAnalyzerDlg (LPCTSTR tzTest, LPCTSTR tzTester, CWnd* pParent = NULL);   // standard constructor
		virtual ~CStAnalyzerDlg();
        static int object_count_;
        int text_control_count_, graph_control_count_;
        static const int /*MINX, MINY, ONED_LEFT, ONED_TOP, ONED_RIGHT, ONED_BOTTOM, RIGHT_PAD, BOTTOM_PAD,*/ pad_ , graph_height_, graph_width_, max_no_graph_per_row_;

	protected:
		

		CChartWrapper* GetGraphWnd(int nSequence);
		CEdit* GetTxtWnd(int nSequence);
		
		nsSTAr::nsChartDataType::enChartLineStyle GetLineStyle(const int nLineStyle);
		nsSTAr::nsChartDataType::enChartPointStyle GetPointStyle(const int nPointStyle);
		COLORREF GetColor(int nColor);
		void GetTime(CString& strTime);
    private:
        CStLineProperty curr_line_prop_;
        std::map<int,CStLineProperty> map_line_prop_;

		int last_plot_id_;
        int last_seq_;
		int prev_xy_color_;
		int prev_xy2_color_;
        int count_plot_line_;
        int last_plot_line;
		int prevVal_;
		bool is_force_close_;
		
        bool call_plot;
        //std::deque<std::pair<int, CPlot_Data> > deq_plots;
        std::map<int, std::deque<std::pair<int, CPlot_Data> > > map_plots;

		std::map<int, CGraphAxisInfo> map_axisinfo_;

		afx_msg LRESULT OnSetCloseMode(WPARAM, LPARAM lparam);
		afx_msg LRESULT OnSetDialogMenu(WPARAM wParam, LPARAM lparam);
		
	public:

		bool CreateSubWindow(int nTextWindow, int nGraphWindow);
		void CloseSubWindow(int nSequence);

		void ResetDialogContent();
		
		void ClearAllData();
		void ClearData(int nSequence);

		void RefreshAllWindow();
		void RefreshWindow(int nSequence);

		void SetAxis(int nSequence, CStAxisProperty& stAxisProp);
		void SetAxis(int nSequence, CStAxisProperty& stAxisProp, int nAxis);

		//void SetLine(int nSequence, CStLineProperty stLineProp);
		void SetLine(int nSequence, CStLineProperty& stLineProp, int nAxis);
					
		////void PlotData(int nSequence, Array1D_Double pXAxisValues, Array1D_Double pYAxisValues);
		////void PlotData(int nSequence, Array1D_Double pXAxisValue, Array1D_Double pYAxisValue, Array1D_Double pY2AxisValue);

		////void PlotData(int nSequence, Array1D_Double pXAxisValues, Array2D_Double pYAxisValues);
		////void PlotData(int nSequence, Array1D_Double pXAxisValues, Array2D_Double pYAxisValues, Array2D_Double pY2AxisValues);

		////void Appenddata(int nSequence, double dXAxisValue, double dYAxisValue);
		////void Appenddata(int nSequence, double pXAxisValue, double pYAxisValue, double pY2AxisValue);

		////void Appenddata(int nSequence, Array1D_Double pXAxisValues, Array1D_Double pYAxisValues);
		////void Appenddata(int nSequence, Array1D_Double pXAxisValues, Array1D_Double pYAxisValues, Array1D_Double pY2AxisValues);

		////void Appenddata(int nSequence, Array1D_Double pXAxisValues, Array2D_Double pYAxisValues);
		////void Appenddata(int nSequence, Array1D_Double pXAxisValues, Array2D_Double pYAxisValues, Array2D_Double pY2AxisValues);
		
		////void Plot_graph(int nSequence, double dXAxisValue, double dYAxisValue, int nUpdateMode);
		////void Plot_graph(int nSequence, double dXAxisValue, double dYAxisValue, double pY2AxisValue, int nUpdateMode);

		////void Plot_graph(int nSequence, Array1D_Double& dXAxisValues, Array1D_Double& dY1AxisValues, Array1D_Double& dY2AxisValues, int nUpdateMode);
		////void Plot_graph(int nSequence, Array1D_Double& dXAxisValues, Array1D_Double& dY1AxisValues, int nUpdateMode);
		////
		////void Plot_graph(int nSequence, Array1D_Double& dXAxisValues, Array2D_Double& dY1AxisValues, int nUpdateMode);
		////void Plot_graph(int nSequence, Array1D_Double& dXAxisValues, Array2D_Double& pYAxisValues, Array2D_Double& pY2AxisValues,int nUpdateMode);

		////void Add_graph(int nSequence, double dXAxisValue, double dYAxisValue);
		////void Add_graph(int nSequence, double dXAxisValue, double dYAxisValue, double dY2AxisValue);

		////void Add_graph(int nSequence, Array1D_Double dXAxisValues, Array1D_Double dY1AxisValues);
		////void Add_graph(int nSequence, Array1D_Double dXAxisValues, Array1D_Double dY1AxisValues, Array1D_Double dY2AxisValues);
		////
		////void Add_graph(int nSequence, Array1D_Double dXAxisValues, Array2D_Double dY1AxisValues);
		////void Add_graph(int nSequence, Array1D_Double dXAxisValues, Array2D_Double pYAxisValues, Array2D_Double pY2AxisValues);

        // new implementation 
        
		//void Plot_graph(int nSequence, double dXAxisValue, double dYAxisValue, int nXYColor, int nUpdateMode);
		//void Plot_graph(int nSequence, double dXAxisValue, double dYAxisValue, double pY2AxisValue, int nXYColor, int nXY2Color, int nUpdateMode);

		//void Plot_graph(int nSequence, Array1D_Double& dXAxisValues, Array1D_Double& dY1AxisValues, Array1D_Double& dY2AxisValues, int nXYColor, int nXY2Color, int nUpdateMode);
		//void Plot_graph(int nSequence, Array1D_Double& dXAxisValues, Array1D_Double& dY1AxisValues, int nXYColor, int nUpdateMode);
		//
		//void Plot_graph(int nSequence, Array1D_Double& dXAxisValues, Array2D_Double& dY1AxisValues, int nXYColor, int nUpdateMode);
		////void Plot_graph(int nSequence, Array1D_Double& dXAxisValues, Array2D_Double& pYAxisValues, Array2D_Double& pY2AxisValues, int nXYColor, int nXY2Color, int nUpdateMode);

		////void Add_graph(int nSequence, double dXAxisValue, double dYAxisValue, int nXYColor);
		////void Add_graph(int nSequence, double dXAxisValue, double dYAxisValue, double dY2AxisValue, int nXYColor, int nXY2Color);

		////void Add_graph(int nSequence, Array1D_Double dXAxisValues, Array1D_Double dY1AxisValues, int nXYColor);
		////void Add_graph(int nSequence, Array1D_Double dXAxisValues, Array1D_Double dY1AxisValues, Array1D_Double dY2AxisValues, int nXYColor, int nXY2Color);
		////
		////void Add_graph(int nSequence, Array1D_Double dXAxisValues, Array2D_Double dY1AxisValues, int nXYColor);
		//////void Add_graph(int nSequence, Array1D_Double dXAxisValues, Array2D_Double pYAxisValues, Array2D_Double pY2AxisValues, int nXYColor, int nXY2Color);
        
  ////     	// end implementation
		////// Thiru 11 July 2006
		////void Plot_graph_pclr(int nSequence, double dXAxisValue, double dYAxisValue, int nXYColor, int nUpdateMode);
		////void Plot_graph_pclr(int nSequence, double dXAxisValue, double dYAxisValue, double pY2AxisValue, int nXYColor, int nXY2Color, int nUpdateMode);

		////void Plot_graph_pclr(int nSequence, Array1D_Double& dXAxisValues, Array1D_Double& dY1AxisValues, Array1D_Double& dY2AxisValues, int nXYColor, int nXY2Color, int nUpdateMode);
		////void Plot_graph_pclr(int nSequence, Array1D_Double& dXAxisValues, Array1D_Double& dY1AxisValues, int nXYColor, int nUpdateMode);
		////
		////void Plot_graph_pclr(int nSequence, Array1D_Double& dXAxisValues, Array2D_Double& dY1AxisValues, int nXYColor, int nUpdateMode);
		void Plot_graph_pclr(int nSequence, Array1D_Double& dXAxisValues, Array2D_Double& pYAxisValues, Array2D_Double& pY2AxisValues, int nXYColor, int nXY2Color, int nUpdateMode);

		////void Add_graph_pclr(int nSequence, double dXAxisValue, double dYAxisValue, int nXYColor);
		////void Add_graph_pclr(int nSequence, double dXAxisValue, double dYAxisValue, double dY2AxisValue, int nXYColor, int nXY2Color);

		////void Add_graph_pclr(int nSequence, Array1D_Double dXAxisValues, Array1D_Double dY1AxisValues, int nXYColor);
		////void Add_graph_pclr(int nSequence, Array1D_Double dXAxisValues, Array1D_Double dY1AxisValues, Array1D_Double dY2AxisValues, int nXYColor, int nXY2Color);
		////
		////void Add_graph_pclr(int nSequence, Array1D_Double dXAxisValues, Array2D_Double dY1AxisValues, int nXYColor);
		void Add_graph_pclr(int nSequence, Array1D_Double dXAxisValues, Array2D_Double pYAxisValues, Array2D_Double pY2AxisValues, int nXYColor, int nXY2Color);
     
		////void Plot_text(int WindowNo, CString ParamName, int Value, int Update  = 0);
		////void Plot_text(int WindowNo, CString ParamName, double Value, int Update  = 0);

		////void Plot_text(int WindowNo, CString ParamName, Array1D_Double& Values, int Update  = 0);
		////void Plot_text(int WindowNo, CString ParamName1, Array1D_Double& Values1, CString ParamName2, Array1D_Double& Values2, int Update  = 0);

		////void Plot_text(int WindowNo, CString ParamName1, Array1D_Double& Values1, CString ParamName2, Array1D_Double& Values2, CString ParamName3, Array1D_Double& Values3, int Update  = 0);
		////void Plot_text(int WindowNo, CString ParamName1, Array2D_Double& Values1, int Update  = 0);
		
        ////void Add_text(int WindowNo, CString ParamName, int Value);

        void Transform(Array1D_Double &Values);
        void Transform(Array2D_Double &Values);
        void Transform(double &Value);

		////void GetText(int WindowNo, CString &cstrCodeOut);
		////void SetText(int WindowNo, CString &cstrCodeOut);

	protected:

		virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
		DECLARE_MESSAGE_MAP()

	public:

		virtual void PostNcDestroy();
		virtual BOOL OnInitDialog();		
		afx_msg void OnClose();
		afx_msg HBRUSH OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor);
		afx_msg void OnDestroy();
		afx_msg void OnExitSizeMove();
		afx_msg LRESULT OnResetDlgContent(WPARAM wParam, LPARAM lParam);
		afx_msg LRESULT OnEnableMenuItem(WPARAM, LPARAM);
		afx_msg LRESULT OnPlotGISText(WPARAM, LPARAM);
		afx_msg LRESULT OnCallGraphFunction(WPARAM wParam, LPARAM lParam);
		afx_msg LRESULT OnCreateSubWindow(WPARAM wparam, LPARAM lparam);
    
private:

        void PositionGraph(const CRect& );
        void GetDimensions(std::vector<CRect>& vecdimensions, const CRect& windowdimension);
        void GetControlWidth(const CRect &windowdimension, int &width,const int total_wnd_count);
        void GetControlHeight(const CRect &windowdimension, int &height,const int total_wnd_count);
        void GetControlDimension(const CRect &windowdimension, int &graph_width, int &graph_height);

    public:
        afx_msg void OnSize(UINT nType, int cx, int cy);
		afx_msg void OnGetMinMaxInfo(MINMAXINFO* lpMMI);
	

		////std::map<int, CTChart *> map_tchart_;
		std::map<int, CTChartLabels> map_label_;
		std::deque<CY1TChartLabels>::iterator itr_deq1;
		std::deque<CY2TChartLabels>::iterator itr_deq2;
		std::deque<CXTChartLabels>::iterator itr_deq3;

		bool val1_;
		bool val2_;
		bool formatcheck_;

		DECLARE_EVENTSINK_MAP()
		void OnGetNextAxisLabelTchart1(long Axis, long LabelIndex, double* LabelValue, BOOL* MoreLabels);
		void OnGetNextAxisLabelTchart2(long Axis, long LabelIndex, double* LabelValue, BOOL* MoreLabels);
		////void OnGetNextAxisLabelTchart3(long Axis, long LabelIndex, double* LabelValue, BOOL* MoreLabels);
		////void OnGetNextAxisLabelTchart4(long Axis, long LabelIndex, double* LabelValue, BOOL* MoreLabels);
		////void OnGetNextAxisLabelTchart5(long Axis, long LabelIndex, double* LabelValue, BOOL* MoreLabels);
		////void OnGetNextAxisLabelTchart6(long Axis, long LabelIndex, double* LabelValue, BOOL* MoreLabels);
		////void OnGetNextAxisLabelTchart7(long Axis, long LabelIndex, double* LabelValue, BOOL* MoreLabels);
		////void OnGetNextAxisLabelTchart8(long Axis, long LabelIndex, double* LabelValue, BOOL* MoreLabels);
		////void OnGetNextAxisLabelTchart9(long Axis, long LabelIndex, double* LabelValue, BOOL* MoreLabels);
		////void OnGetNextAxisLabelTchart10(long Axis, long LabelIndex, double* LabelValue, BOOL* MoreLabels);
		////void OnGetNextAxisLabelTchart11(long Axis, long LabelIndex, double* LabelValue, BOOL* MoreLabels);
		////void OnGetNextAxisLabelTchart12(long Axis, long LabelIndex, double* LabelValue, BOOL* MoreLabels);
		////void OnGetNextAxisLabelTchart13(long Axis, long LabelIndex, double* LabelValue, BOOL* MoreLabels);
		////void OnGetNextAxisLabelTchart14(long Axis, long LabelIndex, double* LabelValue, BOOL* MoreLabels);
		////void OnGetNextAxisLabelTchart15(long Axis, long LabelIndex, double* LabelValue, BOOL* MoreLabels);
		////void OnGetNextAxisLabelTchart16(long Axis, long LabelIndex, double* LabelValue, BOOL* MoreLabels);
		void OnGetAxisLabelTchart1(long Axis, long SeriesIndex, long ValueIndex, BSTR* LabelText);
		void OnGetAxisLabelTchart2(long Axis, long SeriesIndex, long ValueIndex, BSTR* LabelText);
		////void OnGetAxisLabelTchart3(long Axis, long SeriesIndex, long ValueIndex, BSTR* LabelText);
		////void OnGetAxisLabelTchart4(long Axis, long SeriesIndex, long ValueIndex, BSTR* LabelText);
		////void OnGetAxisLabelTchart5(long Axis, long SeriesIndex, long ValueIndex, BSTR* LabelText);
		////void OnGetAxisLabelTchart6(long Axis, long SeriesIndex, long ValueIndex, BSTR* LabelText);
		////void OnGetAxisLabelTchart7(long Axis, long SeriesIndex, long ValueIndex, BSTR* LabelText);
		////void OnGetAxisLabelTchart8(long Axis, long SeriesIndex, long ValueIndex, BSTR* LabelText);
		////void OnGetAxisLabelTchart9(long Axis, long SeriesIndex, long ValueIndex, BSTR* LabelText);
		////void OnGetAxisLabelTchart10(long Axis, long SeriesIndex, long ValueIndex, BSTR* LabelText);
		////void OnGetAxisLabelTchart11(long Axis, long SeriesIndex, long ValueIndex, BSTR* LabelText);
		////void OnGetAxisLabelTchart12(long Axis, long SeriesIndex, long ValueIndex, BSTR* LabelText);
		////void OnGetAxisLabelTchart13(long Axis, long SeriesIndex, long ValueIndex, BSTR* LabelText);
		////void OnGetAxisLabelTchart14(long Axis, long SeriesIndex, long ValueIndex, BSTR* LabelText);
		////void OnGetAxisLabelTchart15(long Axis, long SeriesIndex, long ValueIndex, BSTR* LabelText);
		////void OnGetAxisLabelTchart16(long Axis, long SeriesIndex, long ValueIndex, BSTR* LabelText);
};

