#pragma once

#define WM_ANALYZER_THREAD_SET_FORCE_CLOSE WM_USER + 100
#define WM_ANALYZER_THREAD_RESET_DLG_CONTENT WM_USER + 101
#define WM_ANALYZER_THREAD_SET_DIALOG_MENU WM_USER + 102
#define UWM_ANALYZER_THREAD_CALL_GRAPH_FUNCTION	WM_USER + 103
#define UWM_ANALYZER_THREAD_PLOT_GIS_TEXT	WM_USER + 104



// Forward declaration
class CStAnalyzerDlg;

// CStAnalyzerThread
class CStAnalyzerThread : public CWinThread
{
	DECLARE_DYNCREATE(CStAnalyzerThread)

public:

	static CStAnalyzerThread* CreateAnalyzerThread(const std::string& strTestName, const std::string& strTesterID, int nSizeInPerc, int nTextCount, int nGraphcount, bool bCreateForeGround);
	static CStAnalyzerThread* CreateAnalyzerThread(const std::string& strTestName, const std::string& strTesterID, CRect rect, int nTextCount, int nGraphcount);
	
	virtual ~CStAnalyzerThread();


	// Copy constructor disabled
	CStAnalyzerThread(const CStAnalyzerThread& rhs) = delete;

	// Assignment operator disabled
	CStAnalyzerThread& operator = (const CStAnalyzerThread& rhs) = delete;

	std::string strWindowLabel_;

	CStAnalyzerDlg* GetDialog()
	{
		return pDlg_.get();
	}

	void ResetDialogContent();

public:
	virtual BOOL InitInstance();

	virtual int ExitInstance();

protected:

	CStAnalyzerThread();           // protected constructor used by dynamic creation

	DECLARE_MESSAGE_MAP()

	afx_msg void OnSetForceClose(WPARAM wParam, LPARAM lParam);
	afx_msg void OnResetDialogContent(WPARAM wParam, LPARAM lParam);
	afx_msg void OnSetDialogMenu(WPARAM wParam, LPARAM lParam);
	afx_msg void OnGraphFunction(WPARAM wParam, LPARAM lParam);
	afx_msg void OnPlotGISText(WPARAM wParam, LPARAM lParam);
	
public:

	std::string strTestName_;
	std::string strTesterName_;
	int			nTextCount_;
	int			nGraphCount_;
	CRect		rect_;
	bool		bDialogCreated_;

private:

	std::auto_ptr<CStAnalyzerDlg> pDlg_;

	static CEvent	eventDialogCreated_;

};


